#ifndef __EXTLIBPROCS_H__
#define __EXTLIBPROCS_H__
#include <string.h>
//------------------------------------------------------------
class CSensor;
//int FDBGetSensors(int *N, CSensor *s);
//int FInitDBSensors(const char *ConfigWD);
//------------------------------------------------------------
class CSensor
{public:
//--
 CSensor(){memset(this,0,sizeof(*this));}
 ~CSensor(){clean();}
//---
 void clean();
 CSensor &operator=(const CSensor &b);
 void CopyWithoutAllocation(const CSensor &b);
//--
 int SensorType;
 char *SensorID; int LSensorID;
 char *Description; int LDescription;
//-- for KEEPALIVE:
 int MessageType;//1)IsAlive; 2)IsDead
 time_t EventTime;
 int Status;//bits: 1=Alive/Not alive
//-- ADD1(24.11.07)
 char *SocketNameForCommands; int LSocketNameForCommands;
//--
};	 
//------------------------------------------------------------
inline void clear_string_end(char *str,char *&sb)
{char *s; if(str==NULL||str[0]=='\0'){sb=str;return;} int l=strlen(str);
 for(s=str+l-1; s>=str&&(*s==' '||*s==9||*s=='\n');s--);
 s[1]='\0';
// if(sb)
  for(sb=str;*sb==' '||*sb==9;)sb++;
}
//------------------------------------------------------------
class CMessageEventParam
{public:
 //--
 CMessageEventParam(){memset(this,0,sizeof(*this));}
 ~CMessageEventParam(){clean();}
 //--
 void clean();
 CMessageEventParam &operator=(const CMessageEventParam &b);
 void CopyWithoutAllocation(const CMessageEventParam &b);
 //--
 int Type;//text: 1)int; 2)double; 3)text
 char *Name;int LName;//0-terminated
 char *Val; int LVal;
 //--
};
//==========================================================================
class CMessageEvent
{public:
 //---
 CMessageEvent(){memset(this,0,sizeof(*this));}
 ~CMessageEvent(){clean();}
//---
 void clean();
 CMessageEvent &operator=(const CMessageEvent &b);
 void CopyWithoutAllocation(const CMessageEvent &b);
//---
 int MessageType;
 char *SensorID; int LSensorID;
 int MessageID;
 int SensorType;
 char *EventName; int LEventName;
 time_t EventTime;
 int ParNum;
 CMessageEventParam *par;
//---
};
//==========================================================================
class CMessageEventRequest
{public:
//--
 CMessageEventRequest(){memset(this,0,sizeof(*this));}
 ~CMessageEventRequest(){clean();}
//--
 void clean();
 CMessageEventRequest &operator=(const CMessageEventRequest &b);
 int operator&(CMessageEvent &ev);
//--
 int NMax;int TakeFirst1_Last0;
 int MessageID0,MessageID1; int UseMessageID0,UseMessageID1;
  int MessageType; int UseMessageType;
 char *SensorID; int LSensorID; int UseSensorID;
 int SensorType; int UseSensorType; 
 char *EventName; int LEventName; int UseEventName;
 time_t EventTime0; int UseEventTime0;
 time_t EventTime1; int UseEventTime1;
//--
};
//==========================================================================
class CMessageKeepAlive
{public:
//--
 CMessageKeepAlive(){memset(this,0,sizeof(*this));}
 CMessageKeepAlive &operator=(const CMessageKeepAlive &b);
~CMessageKeepAlive(){clean();}
//--
 void clean();//{delete SensorID; memset(this,0,sizeof(*this));}
//--
 int MessageType;
 char *SensorID; int LSensorID;
 int SensorType; 
 time_t EventTime;
//-
};
//==========================================================================
class CMessageCommand
{public:
//---
 CMessageCommand(){memset(this,0,sizeof(*this));}
 ~CMessageCommand(){clean();}
//---
 void clean();
 CMessageCommand &operator=(const CMessageCommand &b);
 void CopyWithoutAllocation(const CMessageCommand &b);
//---
 int MessageType;
 char *SensorID; int LSensorID;
 int CommandID;
 int CommandType;
 time_t EventTime;
 int ParNum;
 CMessageEventParam *par;
//---
//-- ADD1(24.11.07)
 char *CommandName; int LCommandName;
//--- result of command execution:
 int Result;
 char *ResultInfo; int LResultInfo;

};
//==========================================================================
class CMessageCommandRequest
{public:
 CMessageCommandRequest();
 ~CMessageCommandRequest(){clean();}
 CMessageCommandRequest &operator=(const CMessageCommandRequest &b);
 int operator&(const CMessageCommand &v);
 void clean();
 //--
 int NMax;int TakeFirst1_Last0;
 int MessageType; int UseMessageType;
 char *SensorID; int LSensorID; int UseSensorID;
 int CommandID0,CommandID1; int UseCommandID0,UseCommandID1;
 int CommandType; int UseCommandType;
 time_t CommandTime0; int UseCommandTime0;
 time_t CommandTime1; int UseCommandTime1;
 //--
};
//==========================================================================
#endif
