//==============================================================================
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include "Def.hpp"
#include "DBLib.h"
//========================================================================
#define DEBUG_OUTPUT
//========================================================================
char *GetConfigValue(char (*ss)[512],int &nss,const char *name);
int GetConfigBlock(FILE *f, char (*ss)[512],int &nss);
//==============================================================================
extern CSensor DSensor[100]; extern int NDSensors;
extern CMessageEvent DEvent[1000]; extern int NDEvents;
extern char ConfigDirDebug[512];
//==============================================================================
void CopyPtr(char **to, int *lto, char *from,int lfrom)
{
 delete[] *to; *to=NULL;*lto=0; 
 if(lfrom>0)
 {
  *lto=lfrom; *to=new char[lfrom]; memcpy(*to,from,lfrom);
 }
}
//==========================================================================
void CopyPtr0(char **to, int *lto, char *from,int lfrom)
{
 //(*to)=NULL;
 *lto=lfrom; 
 if(lfrom>0&& (*to)!=NULL)
 {
  memcpy(*to,from,lfrom);
 }
}
//==========================================================================
void CMessageEventParam::clean()
{
 Type=0;//text: 1)int; 2)double; 3)text
 delete[] Name;Name=NULL; LName=0;//0-terminated
 delete[] Val; Val=NULL; LVal=0;
}
//==========================================================================
CMessageEventParam &CMessageEventParam::operator=(const CMessageEventParam &b)
{
 clean();
 Type=b.Type;//text: 1)int; 2)double; 3)text
 LName=b.LName;
 if(LName>0){Name=new char[LName+1]; memcpy(Name,b.Name,LName);}//0-terminated
 LVal=b.LVal;
 if(LVal>0){Val=new char[LVal+1];memcpy(Val,b.Val,LVal);}
return *this;
}
//==========================================================================
void CMessageEventParam::CopyWithoutAllocation(const CMessageEventParam &b)
{
 Type=b.Type;//text: 1)int; 2)double; 3)text
 LName=b.LName;
 if(Name){memcpy(Name,b.Name,LName);}//0-terminated
 LVal=b.LVal;
 if(Val){memcpy(Val,b.Val,LVal);}
}
//==========================================================================
void CSensor::clean()
{
 SensorType=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0;
 delete[] Description; Description=NULL; LDescription=0;
 delete[] SocketNameForCommands; SocketNameForCommands=NULL; LSocketNameForCommands=0;
//-- for KEEPALIVE:
 MessageType=0;
 EventTime=0;
}
//==========================================================================
CSensor &CSensor::operator=(const CSensor &b)
{
 if(this==&b)return *this;
 SensorType=b.SensorType;
 CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
 MessageType=b.MessageType;
 EventTime=b.EventTime;
 CopyPtr(&Description,&LDescription,b.Description,b.LDescription);
 CopyPtr(&SocketNameForCommands,&LSocketNameForCommands,b.SocketNameForCommands,b.LSocketNameForCommands);
 return *this;
}
//==========================================================================
void CSensor::CopyWithoutAllocation(const CSensor &b)
{
 if(this==&b)return;
 SensorType=b.SensorType;
 CopyPtr0(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
 MessageType=b.MessageType;
 EventTime=b.EventTime;
 CopyPtr0(&Description,&LDescription,b.Description,b.LDescription);
}
//==========================================================================
int GetConfigBlock(FILE *f, char (*ss)[512],int &nss)
{int SetInBlock=0,rtn=0;char str[512],*s;
 nss=0;
 while(fgets(str,512,f)!=NULL)
 {str[511]='\0';clear_string_end_with_bells(str);if(str[0]=='\0'||str[0]=='%')continue;
  if(str[0]=='{')
   SetInBlock=1;
  else if(str[0]=='}')
  {SetInBlock=0;rtn=1;break;}
  else
  {
   for(s=str;isspace(*s);s++);
   strcpy(ss[nss++],s);
  }
 }
return rtn;
}
//========================================================================
char *GetConfigValue(char (*ss)[512],int &nss,const char *name)
{static char s[512],sname[512],*s1,*s0; int i,l;
 s[0]='\0';
 strcpy(sname,name);strcat(sname,"=");
 l=strlen(sname);
 for(i=0;i<nss;i++)
  if(strncasecmp(sname,ss[i],l)==0)
   {strcpy(s,ss[i]+l);break;}
 if(strlen(s)>1 && s[0]=='"' && s[strlen(s)-1]=='"')
 {for(s1=s+1,s0=s;*s1!='\0';)*(s0++)=*(s1++);s0[-1]='\0';}
return s;
}
//=========================================================================
static int I0=0;
char *GetConfigValueNext(char (*ss)[512],int &nss,const char *name,int iStart0Continue1)
{static char s[512],sname[512],*s1,*s0; int i,l;
 s[0]='\0';
 strcpy(sname,name);strcat(sname,"=");
 l=strlen(sname);
 for(i=(iStart0Continue1==0?0:I0);i<nss;i++)
  if(strncasecmp(sname,ss[i],l)==0)
   {strcpy(s,ss[i]+l);break;}
 I0=i+1;
 if(strlen(s)>1 && s[0]=='"' && s[strlen(s)-1]=='"')
 {for(s1=s+1,s0=s;*s1!='\0';)*(s0++)=*(s1++);s0[-1]='\0';}
return s;
}
//=========================================================================
void CMessageEvent::clean()
{
 MessageType=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0;
 SensorType=0;
 delete[] EventName; EventName=NULL; LEventName=0;
 EventTime=0;
 MessageID=0;
 delete[] par;
 par=NULL;
 ParNum=0;
}
//==========================================================================
void CMessageEvent::CopyWithoutAllocation(const CMessageEvent &b)
{int i;
if(this==&b)return;
 MessageType=b.MessageType;
 CopyPtr0(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
 SensorType=b.SensorType;
 CopyPtr0(&EventName,&LEventName,b.EventName,b.LEventName);
 EventTime=b.EventTime;
 MessageID=b.MessageID;
  ParNum=b.ParNum;
 if(par)
  for(i=0;i<ParNum;i++)
   par[i].CopyWithoutAllocation(b.par[i]);
}
//==========================================================================
CMessageEvent &CMessageEvent::operator=(const CMessageEvent &b)
{int i;
if(this==&b)return *this;
 MessageType=b.MessageType;
 CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
 SensorType=b.SensorType;
 CopyPtr(&EventName,&LEventName,b.EventName,b.LEventName);
 EventTime=b.EventTime;
 MessageID=b.MessageID;
 if(ParNum!=b.ParNum)
 {
  delete[] par; par=NULL;
  ParNum=b.ParNum;
  if(ParNum>0)
  {
   par=new CMessageEventParam[ParNum];
  }
 }
 for(i=0;i<ParNum;i++)
  par[i]=b.par[i];
return *this;
}
/*
 int MessageType;
 char *SensorID;
 int SensorType;
 char *EventName;
 time_t EventTime;
 int MessageID;//random number (?)
 int ParNum;
 CMessageParam *par;
*/
//==========================================================================
void CMessageEventRequest::clean()
{
 NMax=100; TakeFirst1_Last0=0;
 MessageType=0; UseMessageType=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0; UseSensorID=0;
 SensorType=0; UseSensorType=0; 
 delete[] EventName; EventName=NULL; LEventName=0; UseEventName=0;
 EventTime0=0; UseEventTime0=0;
 EventTime1=0; UseEventTime1=0;
}
//==========================================================================
void CMessageCommand::clean()
{
 delete[] SensorID;
 delete[] par;
 delete[] CommandName;
 delete[] ResultInfo; 
 memset(this,0,sizeof(*this));
}
//==========================================================================
int CMessageEventRequest::operator&(CMessageEvent &ev)
{int rtn=1;
 if(UseMessageType && (MessageType!=0&&MessageType!=ev.MessageType))return 0;
 if(UseMessageID0 && MessageID0>ev.MessageID)return 0;
 if(UseMessageID1 && MessageID1<ev.MessageID)return 0;  
 if(UseSensorID && strcasecmp(SensorID,ev.SensorID)!=0)return 0;
 if(UseSensorType && SensorType!=ev.SensorType)return 0;
 if(UseEventName && strcasecmp(EventName,ev.EventName)!=0)return 0;
 if(UseEventTime0 && ev.EventTime<EventTime0)return 0;
 if(UseEventTime1 && ev.EventTime>EventTime1)return 0;
return rtn;
}
//==========================================================================
CMessageEventRequest &CMessageEventRequest::operator=(const CMessageEventRequest &b)
{
if(this==&b)return *this;
 NMax=b.NMax; TakeFirst1_Last0=b.TakeFirst1_Last0;
 MessageType=b.MessageType; UseMessageType=b.UseMessageType;
 CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID); UseSensorID=b.UseSensorID;
 SensorType=b.SensorType; UseSensorType=b.UseSensorType; 
 CopyPtr(&EventName,&LEventName,b.EventName,b.LEventName); UseEventName=b.UseEventName;
 EventTime0=b.EventTime0; UseEventTime0=b.UseEventTime0;
 EventTime1=b.EventTime1; UseEventTime1=b.UseEventTime1;
return *this;
}
//==========================================================================
CMessageCommandRequest::CMessageCommandRequest()
{
 SensorID=NULL;
 clean();
}
//==========================================================================
CMessageCommandRequest &CMessageCommandRequest::operator=(const CMessageCommandRequest &b)
{
 NMax=b.NMax; TakeFirst1_Last0=b.TakeFirst1_Last0;
 MessageType=b.MessageType;  UseMessageType=b.UseMessageType;
 CopyPtr(&SensorID, &LSensorID, b.SensorID, b.LSensorID); UseSensorID=b.UseSensorID;
 CommandID0=b.CommandID0; CommandID1=b.CommandID1;  
 UseCommandID0=b.UseCommandID0; UseCommandID1=b.UseCommandID1;
 CommandType=b.CommandType; UseCommandType=b.UseCommandType;
 CommandTime0=b.CommandTime0; UseCommandTime0=b.UseCommandTime0;
 CommandTime1=b.CommandTime1; UseCommandTime1=b.UseCommandTime1;
return *this;
}
//==========================================================================
int CMessageCommandRequest::operator&(const CMessageCommand &v)
{
 if(UseMessageType && (MessageType!=0&&MessageType!=v.MessageType))return 0;
 if(UseSensorID && strcasecmp(SensorID,v.SensorID)!=0)return 0;
 if(UseCommandID0 && CommandID0>v.CommandID)return 0;
 if(UseCommandID1 && CommandID1<v.CommandID)return 0;  
 if(UseCommandType && CommandType!=v.CommandType)return 0;
 if(UseCommandTime0 && CommandTime0>v.EventTime)return 0;
 if(UseCommandTime1 && CommandTime1<v.EventTime)return 0;
return 1;
}
//==========================================================================
void CMessageCommand::CopyWithoutAllocation(const CMessageCommand &b)
{int i;
  MessageType=b.MessageType;
  CopyPtr0(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
  CommandID=b.CommandID;
  CommandType=b.CommandType;
  EventTime=b.EventTime;
  ParNum=b.ParNum;
  if(par)
   for(i=0;i<ParNum;i++)
    par[i].CopyWithoutAllocation(b.par[i]);
}
//==========================================================================
CMessageCommand &CMessageCommand::operator=(const CMessageCommand &b)
{int i;
  MessageType=b.MessageType;
  CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
  CopyPtr(&CommandName,&LCommandName,b.CommandName,b.LCommandName);
  CopyPtr(&ResultInfo,&LResultInfo,b.ResultInfo,b.LResultInfo);
  Result=b.Result;
  CommandID=b.CommandID;
  CommandType=b.CommandType;
  EventTime=b.EventTime;
  if(ParNum!=b.ParNum)
  {
   delete[] par; par=NULL;
   ParNum=b.ParNum;
   if(ParNum>0)
   {
    par=new CMessageEventParam[ParNum];
   }
  }
  ParNum=b.ParNum;
  for(i=0;i<ParNum;i++)
   par[i]=b.par[i];

return *this;
}
//==========================================================================
void CMessageCommandRequest::clean()
{
 delete[] SensorID;
 memset(this,0,sizeof(*this));
 NMax=100;
}
//==========================================================================
