#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include "DBLib.h"
/*
//------------------------------------------------------------
*/
#define DefFun(tff,ff,sff) ff=(tff)dlsym(LibHandle,sff); \
    if(ff==NULL){char str[512]; sprintf(str,"Can't load function %s()",sff); printf("%s\n",str); return NULL;}

typedef int (*TFDBGetSensors)(int *N, CSensor **s);
typedef int (*TFDBGetEvents)(int *N, CMessageEvent **s,CMessageEventRequest *req);
typedef int (*TFInitDBSensors)(const char *ConfigWD);
typedef int (*TFInitDBEvents)(const char *ConfigWD);
typedef int (*TFDBSetKeepAlive)(CMessageKeepAlive *message);
typedef int (*TFDBPutEvent)(CMessageEvent *cmd);

int (*FDBGetSensors)(int *N, CSensor **s)=NULL;
int (*FDBGetEvents)(int *N, CMessageEvent **s,CMessageEventRequest *req)=NULL;
int (*FInitDBSensors)(const char *ConfigWD)=NULL;
int (*FInitDBEvents)(const char *ConfigWD)=NULL;
int (*FDBSetKeepAlive)(CMessageKeepAlive *message)=NULL;
int (*FDBPutEvent)(CMessageEvent *cmd)=NULL;

void *LoadExtFuns()
{
 void *LibHandle=dlopen("./DBLib.a", RTLD_LAZY|RTLD_GLOBAL);
 if(LibHandle==NULL){printf("Can't open library\n");return (0);}
 //const char *dlerror(void);
/*
nm ExtLibsProcs.a 

000016c8 T _Z14FWCallMenuItemPKciiPv
00001ef8 T _Z16FWGetBlocksNamesPKcP10SBlockNameiS2_i
00001254 T _Z17FWGetAddMenuItemsPKcRP10SMenuItems
00002340 T _Z19FWGetShortBlockInfoPKcPiPd
0000256c T _Z20FWGetLastErrorStringv
000018f8 T _Z25FWGetConnectedBlocksNamesPKcP10SBlockNameiS2_i
0000246c T _Z25FWGetInfoStringsFromBlockPKciiP11SInfoStringi
00002754 T _Z9FWConnectPKcS0_i
00002596 T _Z9FWInitLibPKc
0000274a T _Z9FWStopLibPKc
*/
printf("Load funs: start\n");
  DefFun(TFDBGetSensors,FDBGetSensors,"FDBGetSensors")
  DefFun(TFDBGetEvents,FDBGetEvents,"FDBGetEvents")
  DefFun(TFInitDBSensors,FInitDBSensors,"FInitDBSensors")
  DefFun(TFInitDBEvents,FInitDBEvents,"FInitDBEvents")
  DefFun(TFDBSetKeepAlive,FDBSetKeepAlive,"FDBSetKeepAlive")
  DefFun(TFDBPutEvent,FDBPutEvent,"FDBPutEvent")
  DefFun(TFDBSetKeepAlive,FDBSetKeepAlive,"FDBSetKeepAlive")
 // DefFun(T,,"")
printf("Load funs: OK\n");
return LibHandle;
}
//------------------------------------------------------------
 CSensor *sensor=NULL; int n_sensors=0;
 CMessageEvent *event=NULL; int n_events=0;
int main()
{int i,rtn;
 void *LibHandle=LoadExtFuns();
 //-----
 FInitDBSensors("../Config");
 FInitDBEvents("../Config");
 //-----
 rtn=FDBGetSensors(&n_sensors, &sensor);
 printf("Sensors number=%d\n",n_sensors);
 for(i=0;i<n_sensors;i++)
 {printf("Sensor[%d]:id=%s\n",i,sensor[i].SensorID); }
 //-----
 rtn=FDBGetEvents(&n_events, &event,NULL);
 printf("Events number=%d\n",n_events);
 for(i=0;i<n_events;i++)
 {printf("Event[%d]:id=%s\n",i,event[i].SensorID); }
 //-----
 CMessageEvent cmd;
  cmd.SensorID=new char[100]; strcpy(cmd.SensorID,"TestSensorEvent");
  cmd.LSensorID=strlen(cmd.SensorID)+1;
 FDBPutEvent(&cmd);
 //-----
 rtn=FDBGetEvents(&n_events, &event,NULL);
 printf("Events number=%d\n",n_events);
 for(i=0;i<n_events;i++)
 {printf("Event[%d]:id=%s\n",i,event[i].SensorID); }
 //-----
 CMessageKeepAlive mes;
  mes.SensorID=new char[100]; strcpy(mes.SensorID,"host1\\comp1\\sensor1");
  mes.EventTime=31415926;
 FDBSetKeepAlive(&mes);

 //-----
 if(LibHandle!=NULL)
  dlclose(LibHandle);
return 0;
}
/*
//--------- to get additional menu items ---------------------
struct SMenuItems
{
 int version;          //0=this version (may be    0|(sizeof(SMenuItems)<<16)    ?)
 //-------
 char name[128];       //text in menu item
 int ID;               //ID for function    int FWCallMenuItem(const char *BlockName, int ID, int type, void *data);
 int type;             //0)menu item; 1)input integer; 2)input double; 3)input string
 //------- type>=1 :
 char TextPrompt[512]; //text for input prompt (may be up to two \n => may be up to 3 output strings)
 int InputInteger; double InputDouble; char InputString[256]; //initial values for input
 //-------
};
//--------- to get blocks names and short blocks description --
struct SBlockName0        // may be - for use instead of blocks names?
{
 int version;             //0=this version
 char name[512];          //main block name, used in functions parameters
 int type;                //0)analyser; 1)converter; 2)receiver
 void Set(int v,const char *n,int t){version=v;name[0]='\0';if(n)strcpy(name,n);type=t;}
};
//--------- to get child anf parent blocks --------------------
struct SBlockName:public SBlockName0
{
 //int version;             //0=this version
 //char name[512];          //main block name, used in functions parameters
 //int type;                //0)analyser; 1)converter; 2)receiver
 int connected;
 char description[1024];  //text description (may have some `\n')
 void Set(int v,const char *n,int t,int c,const char *d)
 {version=v;name[0]='\0';if(n)strcpy(name,n);type=t;connected=c;strcpy(description,d);}
};
//--------- to make graph -------------------------------------
struct SBlockNameItem:public SBlockName
{
 SBlockNameItem()
 {Parents=NULL;Childs=NULL; NParents=0;NChilds=0;
  ConnectedParents=NULL;ConnectedChilds=NULL; NConnectedParents=0;NConnectedChilds=0;
 }
 ~SBlockNameItem(){clean();}
 void clean()
 {delete[] Parents; delete[] Childs; Parents=NULL;Childs=NULL; NParents=0;NChilds=0;
  delete[] ConnectedParents; delete[] ConnectedChilds; 
  ConnectedParents=NULL;ConnectedChilds=NULL; NConnectedParents=0;NConnectedChilds=0;
 }
 void Set(int v,const char *n,int t,int c,const char *d, int NParents,int NChilds)
 {SBlockName::Set(v,n,t,c,d);clean(); 
  if(NParents>0)
  {Parents=new SBlockNameItem*[this->NParents=NParents];
   ConnectedParents=new SBlockNameItem*[NParents];this->NConnectedParents=0;
  }
  if(NChilds>0)
  {Childs=new SBlockNameItem*[this->NChilds=NChilds];
   ConnectedChilds=new SBlockNameItem*[NChilds];this->NConnectedChilds=0;
  }
 }
 SBlockNameItem **Parents,**Childs; int NParents,NChilds;
 SBlockNameItem **ConnectedParents,**ConnectedChilds; int NConnectedParents,NConnectedChilds;
};
//--------- to get info strings from block -------------------
struct SInfoString
{
 int version;             //0=this version
 char str[512];           //info string itself
 int ID;                  //string ID
 double DangerLevel;      //danger level (for string color in output field)
};
//------------------------------------------------------------
//I call when program start
int FWInitLib(const char *ss);
//I call when program stop
int FWStopLib(const char *ss);
// I call, when I want to get additional menu prompts
int FWGetAddMenuItems(const char *BlockName, SMenuItems *&MenuItems);
// I call after menu item choose
int FWCallMenuItem(const char *BlockName, int ID, int type, void *data);
// To get parent and child blocks names and description of this block
int FWGetBlocksNames(const char *BaseBlockName,  
                     SBlockName *ChildBlockNames, int NChildBlockNamesMax,
                     SBlockName *ParentBlockNames, int NParentBlockNamesMax);
// To get connected parent and child blocks names and description of this block
int FWGetConnectedBlocksNames(const char *BaseBlockName,  
                     SBlockName *ChildBlockNames, int NChildBlockNamesMax,
                     SBlockName *ParentBlockNames, int NParentBlockNamesMax);
// To get short block info
int FWGetShortBlockInfo(const char *BaseBlockName,  int *State, double *DangerLevel);
// To get last info strings from block (used strings immediately after string with some ID) 
int FWGetInfoStringsFromBlock(const char *BlockName,  int IDOfLastTransmitedString, int NStringsBefore,
                              SInfoString *InfoStrings, int NInfoStringsMax);
// To connect(SetConnect=1) / disconnect(SetConnect=0) ChildBlock to/from ParentBlock 
int FWConnect(const char *ChildBlock, const char *ParentBlock, int SetConnect);
// To get error string from last command
char *FWGetLastErrorString(); 
//------------------------------------------------------------
extern char StrLastErrorString[1024];//="";
//------------------------------------------------------------
#endif
*/
void CSensor::clean()
{
 SensorType=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0;
 delete[] Description; Description=NULL; LDescription=0;
 delete[] SocketNameForCommands; SocketNameForCommands=NULL; LSocketNameForCommands=0;
//-- for KEEPALIVE:
 MessageType=0;
 EventTime=0;
}
void CMessageEvent::clean()
{
	 MessageType=0;
	  delete[] SensorID; SensorID=NULL; LSensorID=0;
	   SensorType=0;
	    delete[] EventName; EventName=NULL; LEventName=0;
	     EventTime=0;
	      MessageID=0;
	       delete[] par;
	        par=NULL;
		 ParNum=0;
}
void CMessageEventParam::clean()
{
	 Type=0;//text: 1)int; 2)double; 3)text
	  delete[] Name;Name=NULL; LName=0;//0-terminated
	   delete[] Val; Val=NULL; LVal=0;
}
void CMessageKeepAlive::clean()
{delete SensorID; memset(this,0,sizeof(*this));}

