//==============================================================================
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <malloc.h>
#include "Def.hpp"
#include "DBLib.h"
//========================================================================
#define DEBUG_OUTPUT
//========================================================================
char *GetConfigValue(char (*ss)[512],int *nss,const char *name);
int GetConfigBlock(FILE *f, char (*ss)[512],int *nss);
//==============================================================================
extern struct CSensor DSensor[100]; extern int NDSensors;
extern struct CMessageEvent DEvent[1000]; extern int NDEvents;
extern char ConfigDirDebug[512];
//==============================================================================
void CopyPtr(char **to, int *lto, char *from,int lfrom)
{
 if(to && *to)free(*to); *to=NULL;*lto=0; 
 if(lfrom>0)
 {
  *lto=lfrom; *to=(char*)malloc(lfrom); memcpy(*to,from,lfrom);
 }
}
//==========================================================================
void CSensor_clean(struct CSensor * s)
{
 s->SensorType=0;
 free(s->SensorID); s->SensorID=NULL; s->LSensorID=0;
 free(s->Description); s->Description=NULL; s->LDescription=0;
//-- for KEEPALIVE:
 s->MessageType=0;
 s->EventTime=0;
}
//==========================================================================
void  CSensor_copy(struct CSensor *a,struct CSensor *b)
{
 if(a==b)return;
 a->SensorType=b->SensorType;
 CopyPtr(&(a->SensorID),&(a->LSensorID),b->SensorID,b->LSensorID);
 a->MessageType=b->MessageType;
 a->EventTime=b->EventTime;
 CopyPtr(&(a->Description),&(a->LDescription),b->Description,b->LDescription);
}
//==========================================================================
int GetConfigBlock(FILE *f, char (*ss)[512],int *nss)
{int SetInBlock=0,rtn=0;char str[512],*s;
 *nss=0;
 while(fgets(str,512,f)!=NULL)
 {str[511]='\0';clear_string_end_with_bells(str);if(str[0]=='\0'||str[0]=='%')continue;
  if(str[0]=='{')
   SetInBlock=1;
  else if(str[0]=='}')
  {SetInBlock=0;rtn=1;break;}
  else
  {
   for(s=str;isspace(*s);s++);
   strcpy(ss[(*nss)++],s);
  }
 }
return rtn;
}
//========================================================================
char *GetConfigValue(char (*ss)[512],int *nss,const char *name)
{static char s[512],sname[512],*s1,*s0; int i,l;
 s[0]='\0';
 strcpy(sname,name);strcat(sname,"=");
 l=strlen(sname);
 for(i=0;i<*nss;i++)
  if(strncasecmp(sname,ss[i],l)==0)
   {strcpy(s,ss[i]+l);break;}
 if(strlen(s)>1 && s[0]=='"' && s[strlen(s)-1]=='"')
 {for(s1=s+1,s0=s;*s1!='\0';)*(s0++)=*(s1++);s0[-1]='\0';}
return s;
}
//=========================================================================
void CMessageEvent_clean(struct CMessageEvent *s)
{
 s->MessageType=0;
 free(s->SensorID); s->SensorID=NULL; s->LSensorID=0;
 s->SensorType=0;
 free(s->EventName); s->EventName=NULL; s->LEventName=0;
 s->EventTime=0;
 s->MessageID=0;
 free(s->par);
 s->par=NULL;
 s->ParNum=0;
}
//==========================================================================
void CMessageEvent_copy(struct CMessageEvent *a,struct CMessageEvent *b)
{int i;
if(a==b)return;
 a->MessageType=b->MessageType;
 CopyPtr(&(a->SensorID),&(a->LSensorID),b->SensorID,b->LSensorID);
 a->SensorType=b->SensorType;
 CopyPtr(&(a->EventName),&(a->LEventName),b->EventName,b->LEventName);
 a->EventTime=b->EventTime;
 a->MessageID=b->MessageID;
 if(a->ParNum!=b->ParNum)
 {
  if(a->par)free(a->par); a->par=NULL;
  a->ParNum=b->ParNum;
  if(a->ParNum>0)
  {
   a->par=(struct CMessageEventParam*)malloc(sizeof(struct CMessageEventParam)*a->ParNum);
   for(i=0;i<a->ParNum;i++)CMessageEventParam_init(a->par[i]);
  }
 }
 for(i=0;i<a->ParNum;i++)
  CMessageEventParam_copy(a->par+i,b->par+i);
}
/*
 int MessageType;
 char *SensorID;
 int SensorType;
 char *EventName;
 time_t EventTime;
 int MessageID;//random number (?)
 int ParNum;
 CMessageParam *par;
*/
//==========================================================================
void CMessageEventRequest_clean(struct CMessageEventRequest *s)
{
 s->NMax=100; s->TakeFirst1_Last0=0;
 s->MessageType=0; s->UseMessageType=0;
 free(s->SensorID); s->SensorID=NULL; s->LSensorID=0; s->UseSensorID=0;
 s->SensorType=0; s->UseSensorType=0; 
 free(s->EventName); s->EventName=NULL; s->LEventName=0; s->UseEventName=0;
 s->EventTime0=0; s->UseEventTime0=0;
 s->EventTime1=0; s->UseEventTime1=0;
}
//==========================================================================
int CMessageEventRequest_cmp(struct CMessageEventRequest *r,struct CMessageEvent *ev)
{int rtn=1;
 if(r->UseMessageType && r->MessageType!=ev->MessageType)return 0;
 if(r->UseSensorID && strcasecmp(r->SensorID,ev->SensorID)!=0)return 0;
 if(r->UseSensorType && r->SensorType!=ev->SensorType)return 0;
 if(r->UseEventName && strcasecmp(r->EventName,ev->EventName)!=0)return 0;
 if(r->UseEventTime0 && ev->EventTime<r->EventTime0)return 0;
 if(r->UseEventTime1 && ev->EventTime>r->EventTime1)return 0;
return rtn;
}
//==========================================================================
void CMessageEventRequest_copy(struct CMessageEventRequest *a,struct CMessageEventRequest *b)
{
if(a==b)return;
 a->NMax=b->NMax; a->TakeFirst1_Last0=b->TakeFirst1_Last0;
 a->MessageType=b->MessageType; a->UseMessageType=b->UseMessageType;
 CopyPtr(&(a->SensorID),&(a->LSensorID),b->SensorID,b->LSensorID); a->UseSensorID=b->UseSensorID;
 a->SensorType=b->SensorType; a->UseSensorType=b->UseSensorType; 
 CopyPtr(&(a->EventName),&(a->LEventName),b->EventName,b->LEventName); a->UseEventName=b->UseEventName;
 a->EventTime0=b->EventTime0; a->UseEventTime0=b->UseEventTime0;
 a->EventTime1=b->EventTime1; a->UseEventTime1=b->UseEventTime1;
}
//==========================================================================

