//==============================================================================
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <malloc.h>
#include "Def.hpp"
#include "DBLib.h"
//========================================================================
#define DEBUG_OUTPUT
//========================================================================
char *GetConfigValue(char (*ss)[512],int *nss,const char *name);
int GetConfigBlock(FILE *f, char (*ss)[512],int *nss);
//==============================================================================
struct CSensor DSensor[100]; int NDSensors=0;
struct CMessageEvent DEvent[1000]; int NDEvents=0;
char ConfigDirDebug[512];
//==============================================================================
void CopyPtr(char **to, int *lto, char *from,int lfrom);
//==========================================================================
int FInitDBSensors(const char* ConfigDir)
{int rtn=0,nss;char str[512],ss[20][512]; char *s=NULL,sf[512];
#ifdef DEBUG_OUTPUT
// printf("DLL:FInitDBSensors:1\n");
#endif
 NDSensors=0;
 sprintf(sf,"%s/DebugInitSensor.txt",ConfigDir);
 FILE *f=fopen(sf,"r");
 if(f)
 {
// printf("DLL:FInitDBSensors:2\n");
  while(GetConfigBlock(f, ss,&nss))
  {
   s=GetConfigValue(ss,&nss,"ID");
   if( s!=NULL && s[0]!='\0' )
   {
    //--
    DSensor[NDSensors].LSensorID=strlen(s)+1;
    DSensor[NDSensors].SensorID=(char*)malloc(DSensor[NDSensors].LSensorID);
    strcpy(DSensor[NDSensors].SensorID,s);
    //--
    s=GetConfigValue(ss,&nss,"Type");
    DSensor[NDSensors].SensorType=0;
    if( s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DSensor[NDSensors].SensorType);
    //--
    s=GetConfigValue(ss,&nss,"Description");
    if( s!=NULL && s[0]!='\0' )
    {
     DSensor[NDSensors].LDescription=strlen(s)+1;
     DSensor[NDSensors].Description=(char*)malloc(DSensor[NDSensors].LDescription);
     strcpy(DSensor[NDSensors].Description,s);
    }
    //--
    s=GetConfigValue(ss,&nss,"IsAlive");
    if( s!=NULL && s[0]!='\0' )
    {
     DSensor[NDSensors].MessageType=((strcasecmp(s,"yes")==0)?1:2);
    }
    //--
    NDSensors++;
   }
  }
  fclose(f);
 }
return rtn;
}
//==========================================================================
int FDBGetSensors(int *N, struct CSensor *s)
{int rtn=0;
 if(N==NULL)return -1;
 *N=NDSensors;
 if(s)
 {int i;
  for(i=0;i<NDSensors;i++)
   CSensor_copy(s+i,DSensor+i);
 }
return rtn;
}
//==========================================================================

int FInitDBEvents(const char *ConfigDir)
{int rtn=0,nss;char str[512],ss[20][512],sf[512]; char *s;
strcpy(ConfigDirDebug,ConfigDir);
 NDEvents=0;
 sprintf(sf,"%s/DebugInitEvents.txt",ConfigDir);
 FILE *f=fopen(sf,"r");
 if(f)
 {
  while(GetConfigBlock(f, ss,&nss))
  {
/*
 int MessageType;
 char *SensorID; int LSensorID;
 int SensorType;
 char *EventName; int LEventName;
 time_t EventTime;
 int MessageID;//random number (?)
 int ParNum;
 CMessageEventParam *par;*/
   s=GetConfigValue(ss,&nss,"SENSOR_ID");
   if(s!=NULL && s[0]!='\0' )
   {
    //--
    DEvent[NDEvents].LSensorID=strlen(s)+1;
    DEvent[NDEvents].SensorID=(char*)malloc(DEvent[NDEvents].LSensorID);
    strcpy(DEvent[NDEvents].SensorID,s);
    //--
    s=GetConfigValue(ss,&nss,"SENSOR_TYPE");
    DEvent[NDEvents].SensorType=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DEvent[NDEvents].SensorType);
    //--
    s=GetConfigValue(ss,&nss,"EVENT_NAME");
    DEvent[NDEvents].LEventName=strlen(s)+1;
    DEvent[NDEvents].EventName=(char*)malloc(DEvent[NDEvents].LEventName);
    strcpy(DEvent[NDEvents].EventName,s);
    //--
    s=GetConfigValue(ss,&nss,"EVENT_TIME");
    DEvent[NDEvents].EventTime=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DEvent[NDEvents].EventTime);
    //--
    NDEvents++;
   }
  }
  fclose(f);
 }
return rtn;
}
//==========================================================================
int FDBGetEvents(int *N, struct CMessageEvent *event, struct CMessageEventRequest *request)
{int rtn=0;
FInitDBEvents(ConfigDirDebug);
//printf("(FDBGetEvents>>)N=%d\n",NDEvents);
 if(N==NULL)return -1;
 if(N)
 {
  *N=NDEvents;
 }
 if(event)
 {int i;
  for(i=NDEvents-1;i>=0;i--)
   CMessageEvent_copy(event+i,DEvent+i);
 }
return rtn;
}
//==========================================================================

