//==============================================================================
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include "Def.hpp"
#include "DBLib.h"
//========================================================================
#define DEBUG_OUTPUT
//========================================================================
char *GetConfigValue(char (*ss)[512],int &nss,const char *name);
char *GetConfigValueNext(char (*ss)[512],int &nss,const char *name,int SetStart0Continue1);
int GetConfigBlock(FILE *f, char (*ss)[512],int &nss);
//==============================================================================
CSensor DSensor[1000]; int NDSensors=0;
CMessageEvent DEvent[1000]; int NDEvents=0;
CMessageCommand DCommand[1000]; int NDCommands=0;
char ConfigDirDebug[512];
//==============================================================================
void CopyPtr(char **to, int *lto, char *from,int lfrom);
//==========================================================================
int FInitDBSensors(const char* ConfigDir)
{int rtn=0,nss;char str[512],ss[20][512]; char *s=NULL,sf[512];
#ifdef DEBUG_OUTPUT
// printf("DLL:FInitDBSensors:1\n");
#endif
 NDSensors=0;
 sprintf(sf,"%s/DebugInitSensor.txt",ConfigDir);
 FILE *f=fopen(sf,"r");
 if(f)
 {
// printf("DLL:FInitDBSensors:2\n");
  while(GetConfigBlock(f, ss,nss))
  {
   s=GetConfigValue(ss,nss,"ID");
   if( s!=NULL && s[0]!='\0' )
   {
    //--
    DSensor[NDSensors].LSensorID=strlen(s)+1;
    DSensor[NDSensors].SensorID=new char[DSensor[NDSensors].LSensorID];
    strcpy(DSensor[NDSensors].SensorID,s);
    //--
    s=GetConfigValue(ss,nss,"Type");
    DSensor[NDSensors].SensorType=0;
    if( s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DSensor[NDSensors].SensorType);
    //--
    s=GetConfigValue(ss,nss,"Description");
    if( s!=NULL && s[0]!='\0' )
    {
     DSensor[NDSensors].LDescription=strlen(s)+1;
     DSensor[NDSensors].Description=new char[DSensor[NDSensors].LDescription];
     strcpy(DSensor[NDSensors].Description,s);
    }
    //--
    s=GetConfigValue(ss,nss,"IsAlive");
    if( s!=NULL && s[0]!='\0' )
    {
     DSensor[NDSensors].MessageType=((strcasecmp(s,"yes")==0)?1:2);
    }
    //--
    NDSensors++;
   }
  }
  fclose(f);
  printf("InitDBSesors:%d sensors\n",NDSensors);
 }
return rtn;
}
//==========================================================================
int FDBGetSensors(int *N, CSensor *s,int *IDSet)
{int rtn=0;
 if(N==NULL)return sizeof(CSensor);
 *N=NDSensors;
 if(s)
 {int i;
  for(i=0;i<NDSensors;i++)
   s[i].CopyWithoutAllocation(DSensor[i]);
 }
return rtn;
}
//==========================================================================
int FInitDBEvents(const char *ConfigDir)
{int rtn=0,nss;char str[512],ss[20][512],sf[512]; char *s;
strcpy(ConfigDirDebug,ConfigDir);
 NDEvents=0;
 sprintf(sf,"%s/DebugInitEvents.txt",ConfigDir);
 FILE *f=fopen(sf,"r");
 if(f)
 {
  while(GetConfigBlock(f, ss,nss))
  {
/*
 int MessageType;
 char *SensorID; int LSensorID;
 int SensorType;
 char *EventName; int LEventName;
 time_t EventTime;
 int MessageID;//random number (?)
 int ParNum;
 CMessageEventParam *par;*/
   s=GetConfigValue(ss,nss,"SENSOR_ID");
   if(s!=NULL && s[0]!='\0' )
   {
    //--
    DEvent[NDEvents].LSensorID=strlen(s)+1;
    DEvent[NDEvents].SensorID=new char[DEvent[NDEvents].LSensorID];
    strcpy(DEvent[NDEvents].SensorID,s);
    //--
    s=GetConfigValue(ss,nss,"SENSOR_TYPE");
    DEvent[NDEvents].SensorType=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DEvent[NDEvents].SensorType);
    //--
    s=GetConfigValue(ss,nss,"EVENT_ID");
    DEvent[NDEvents].MessageID=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DEvent[NDEvents].MessageID);
    //--
    s=GetConfigValue(ss,nss,"EVENT_NAME");
    DEvent[NDEvents].LEventName=strlen(s)+1;
    DEvent[NDEvents].EventName=new char[DEvent[NDEvents].LEventName];
    strcpy(DEvent[NDEvents].EventName,s);
    //--
    s=GetConfigValue(ss,nss,"EVENT_TIME");
    DEvent[NDEvents].EventTime=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DEvent[NDEvents].EventTime);
    //--
    s=GetConfigValue(ss,nss,"PAR_NUMBER");
    if(s!=NULL && s[0]!='\0')
    {
     sscanf(s,"%d",&DEvent[NDEvents].ParNum);
     delete[] DEvent[NDEvents].par; DEvent[NDEvents].par=NULL; 
     if(DEvent[NDEvents].ParNum>0)
     {int ip;
      DEvent[NDEvents].par=new CMessageEventParam[DEvent[NDEvents].ParNum];
      for(ip=0;ip<DEvent[NDEvents].ParNum;ip++)
      {
       s=GetConfigValueNext(ss,nss,"PAR_NAME",ip);
        CopyPtr(&DEvent[NDEvents].par[ip].Name,&DEvent[NDEvents].par[ip].LName,s,strlen(s)+1);
       s=GetConfigValueNext(ss,nss,"PAR_TYPE",ip);
        if(s)sscanf(s,"%d",&DEvent[NDEvents].par[ip].Type);
       s=GetConfigValueNext(ss,nss,"PAR_VALUE",ip);
       if(s)
       {
        if(DEvent[NDEvents].par[ip].Type==1)
        {int *x=new int[1]; sscanf(s,"%d",x); DEvent[NDEvents].par[ip].Val=(char*)x; DEvent[NDEvents].par[ip].LVal=sizeof(int);}
        else if(DEvent[NDEvents].par[ip].Type==2)
        {double *x=new double[1]; sscanf(s,"%lg",x); DEvent[NDEvents].par[ip].Val=(char*)x; DEvent[NDEvents].par[ip].LVal=sizeof(double);}
        else if(DEvent[NDEvents].par[ip].Type==3)
        {CopyPtr(&DEvent[NDEvents].par[ip].Val,&DEvent[NDEvents].par[ip].LVal,s,strlen(s)+1);}
       }
      }
      DEvent[NDEvents].LEventName=strlen(s)+1;
      DEvent[NDEvents].EventName=new char[DEvent[NDEvents].LEventName];
      strcpy(DEvent[NDEvents].EventName,s);
     }
    }
    //--
    NDEvents++;
   }
  }
  fclose(f);
  printf("InitDBEvents:%d events\n",NDEvents);
 }
return rtn;
}
//==========================================================================
int FDBGetEvents(int *N, CMessageEvent *event, CMessageEventRequest *request, int *IDSet)
{int rtn=0;
//FInitDBEvents(ConfigDirDebug);
//printf("(FDBGetEvents>>)N=%d\n",NDEvents);
 if(N==NULL)return sizeof(CMessageEvent)|(sizeof(CMessageEventRequest)<<16);
 if(N)
 {
  *N=NDEvents;
 }
 if(event&&request==NULL)
 {int i;
  for(i=NDEvents-1;i>=0;i--)
   event[i].CopyWithoutAllocation(DEvent[i]);
 }
 if(request)
 {int n=0;
  if(request->TakeFirst1_Last0!=0)//FIRST
  {int i;
   for(i=0;i<NDEvents;i++)
   {
    if((*request)&DEvent[i])
    {
     if(event)
      event[n].CopyWithoutAllocation(DEvent[i]);
     n++;
     if(n>=request->NMax)break;
    }
   }
  }
  else//LAST
  {int i;
   for(i=NDEvents-1;i>=0;i--)
   {
    if((*request)&DEvent[i])
    {
     if(event)
      event[n].CopyWithoutAllocation(DEvent[i]);
     n++;
     if(n>=request->NMax)break;
    }
   }
  }
  *N=n;
 }
return rtn;
}
//==========================================================================
int FInitDBCommands(const char *ConfigDir)
{int rtn=0,nss;char str[512],ss[20][512],sf[512]; char *s;
strcpy(ConfigDirDebug,ConfigDir);
 NDCommands=0;
 sprintf(sf,"%s/DebugInitCommands.txt",ConfigDir);
 FILE *f=fopen(sf,"r");
 if(f)
 {
  while(GetConfigBlock(f, ss,nss))
  {
/*
{
 SENSOR_ID="host2\\sensor1"
 COMMAND_ID=1021
 COMMAND_TYPE=2
 COMMAND_TIME=1070
}
    */
   s=GetConfigValue(ss,nss,"SENSOR_ID");
   if(s!=NULL && s[0]!='\0' )
   {
    //--
    DCommand[NDCommands].LSensorID=strlen(s)+1;
    DCommand[NDCommands].SensorID=new char[DCommand[NDCommands].LSensorID];
    strcpy(DCommand[NDCommands].SensorID,s);
    //--
    s=GetConfigValue(ss,nss,"COMMAND_ID");
    DCommand[NDCommands].CommandID=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DCommand[NDCommands].CommandID);
    //--
    s=GetConfigValue(ss,nss,"COMMAND_TYPE");
    DCommand[NDCommands].CommandType=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DCommand[NDCommands].CommandType);
    //--
    s=GetConfigValue(ss,nss,"COMMAND_TIME");
    DCommand[NDCommands].EventTime=0;
    if(s!=NULL && s[0]!='\0' )
     sscanf(s,"%d",&DCommand[NDCommands].EventTime);
    //--
    s=GetConfigValue(ss,nss,"PAR_NUMBER");
    if(s!=NULL && s[0]!='\0')
    {
     sscanf(s,"%d",&DCommand[NDCommands].ParNum);
     delete[] DCommand[NDCommands].par; DCommand[NDCommands].par=NULL; 
     if(DCommand[NDCommands].ParNum>0)
     {int ip;
      DCommand[NDCommands].par=new CMessageEventParam[DCommand[NDCommands].ParNum];
      for(ip=0;ip<DCommand[NDCommands].ParNum;ip++)
      {
       s=GetConfigValueNext(ss,nss,"PAR_NAME",ip);
        CopyPtr(&DCommand[NDCommands].par[ip].Name,&DCommand[NDCommands].par[ip].LName,s,strlen(s)+1);
       s=GetConfigValueNext(ss,nss,"PAR_TYPE",ip);
        if(s)sscanf(s,"%d",&DCommand[NDCommands].par[ip].Type);
       s=GetConfigValueNext(ss,nss,"PAR_VALUE",ip);
       if(s)
       {
        if(DCommand[NDCommands].par[ip].Type==1)
        {int *x=new int[1]; sscanf(s,"%d",x); DCommand[NDCommands].par[ip].Val=(char*)x; DCommand[NDCommands].par[ip].LVal=sizeof(int);}
        else if(DCommand[NDCommands].par[ip].Type==2)
        {double *x=new double[1]; sscanf(s,"%lg",x); DCommand[NDCommands].par[ip].Val=(char*)x; DCommand[NDCommands].par[ip].LVal=sizeof(double);}
        else if(DCommand[NDCommands].par[ip].Type==3)
        {CopyPtr(&DCommand[NDCommands].par[ip].Val,&DCommand[NDCommands].par[ip].LVal,s,strlen(s)+1);}
       }
      }
      DEvent[NDEvents].LEventName=strlen(s)+1;
      DEvent[NDEvents].EventName=new char[DEvent[NDEvents].LEventName];
      strcpy(DEvent[NDEvents].EventName,s);
     }
    }
    //--
    NDCommands++;
   }
  }
  fclose(f);
  printf("InitDBCommands:%d commands\n",NDCommands);
 }
return rtn;
}
//==========================================================================
int FDBPutCommand(CMessageCommand *cmd)
{
 DCommand[NDCommands++]=*cmd;
return 0;
}
//==========================================================================
int FDBPutEvent(CMessageEvent *cmd)
{
 DEvent[NDEvents++]=*cmd;
return 0;
}
//==========================================================================
int FDBGetCommands(int *N, CMessageCommand *cmd, CMessageCommandRequest *request, int *IDSet)
{int rtn=0;
//FInitDBCommands(ConfigDirDebug);
//printf("(FDBGetEvents>>)N=%d\n",NDEvents);
 if(N==NULL)return sizeof(CMessageCommand)|(sizeof(CMessageCommandRequest)<<16);
 if(request==NULL)
 {
  if(N)
  {
   *N=NDCommands;
  }
  if(cmd)
  {int i;
   for(i=NDCommands-1;i>=0;i--)
    cmd[i].CopyWithoutAllocation(DCommand[i]);
  }
 }
 else
 {int n=0;
  if(request->TakeFirst1_Last0!=0)//FIRST
  {int i;
   for(i=0;i<NDCommands;i++)
   {
    if((*request)&DCommand[i])
    {
     if(cmd)
      cmd[n].CopyWithoutAllocation(DCommand[i]);
     n++;
     if(n>=request->NMax)break;
    }
   }
  }
  else//LAST
  {int i;
   for(i=NDCommands-1;i>=0;i--)
   {
    if((*request)&DCommand[i])
    {
     if(cmd)
      cmd[n].CopyWithoutAllocation(DCommand[i]);
     n++;
     if(n>=request->NMax)break;
    }
   }
  }
  *N=n;
 }
return rtn;
}
//==========================================================================
int FDBDeleteCommand(int id)
{int i,j;
 for(i=0;i<NDCommands;i++)if(DCommand[i].CommandID==id)
 {
  for(j=i+1;j<NDCommands;j++)
   DCommand[j-1]=DCommand[j];
  NDCommands--;
  break;
 }
return 0;
}
//==========================================================================

int FDBDeleteEvent(int id)
{int i,j;
 for(i=0;i<NDEvents;i++)if(DEvent[i].MessageID==id)
 {
  for(j=i+1;j<NDEvents;j++)
   DEvent[j-1]=DEvent[j];
  NDEvents--;
  break;
 }
return 0;
}
//==========================================================================

