/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "w.h"
#include "cwd_commandslist.h"

CWD_CommandsList::CWD_CommandsList(QWidget *parent, const char *name,const char *SensorName)
    :DCommandsList(parent, name)
{int i;
 NMax->setText("100");
 listCommands->setColumnWidthMode (0 , QListView::Manual );
 listCommands->setColumnWidth ( 0, 20 );//enum WidthMode { Manual, Maximum };
 IDFirst=0;IDLast=0; iFirst=0;iLast=0;
 //QButtonGroup
 BG_WhichGet->setButton(ELast);
 BG_Type->setButton(EAll);
 AccSensorID=3;
 SensorNameMask=(SensorName?SensorName:"");
 onSetTimeFrom(2);
 onSetTimeTo(0);
 timeToUsed->setChecked(FALSE);
 timeFromUsed->setChecked(FALSE);
 timer=NULL;
 setCaption(name);
 itemSelected=NULL;
 firstPaint=1;
update();
 ResetData();
//-----------
 for(i=0;i<10;i++)ColumnsVisibiliy[i]=1;
 NColumns=6;
  Menu1 = new QPopupMenu( this );
         Menu1->setCheckable(TRUE);
         Menu1->insertItem(  "Number",  this, SLOT(FSetVisibilityC0()), 0);
         Menu1->insertItem(  "Sensor",  this, SLOT(FSetVisibilityC1()), 0);
         Menu1->insertItem(  "ID",  this, SLOT(FSetVisibilityC2()), 0);
         Menu1->insertItem(  "Type",  this, SLOT(FSetVisibilityC3()), 0);
         Menu1->insertItem(  "Date",  this, SLOT(FSetVisibilityC4()), 0);
         Menu1->insertItem(  "Params",  this, SLOT(FSetVisibilityC5()), 0);
            Menu1->setItemChecked(Menu1->idAt(0),ColumnsVisibiliy[0]);
            Menu1->setItemChecked(Menu1->idAt(1),ColumnsVisibiliy[1]);
            Menu1->setItemChecked(Menu1->idAt(2),ColumnsVisibiliy[2]);
            Menu1->setItemChecked(Menu1->idAt(3),ColumnsVisibiliy[3]);
            Menu1->setItemChecked(Menu1->idAt(4),ColumnsVisibiliy[4]);
            Menu1->setItemChecked(Menu1->idAt(5),ColumnsVisibiliy[5]);
  //       Menu0->insertSeparator ();
//----------
  QMenuBar *menu = new QMenuBar( this );
  menu->insertItem( "&Columns", Menu1 );
//----------
  itemSelected=NULL;
//----------
 ResizeColumns();
}

CWD_CommandsList::~CWD_CommandsList()
{
delete timer;timer=NULL;
}

int CWD_CommandsList::ResetData()
{//QListView DBGetEvents
int i,IDSet,rtn=0,N; CMessageCommand *command=NULL; CMessageCommandRequest request; QDateTime t;
 listCommands->clear();
 iFirst=iLast=0;
 //--
 request.NMax=NMax->text().toInt();//QLineEdit
 request.TakeFirst1_Last0=BG_WhichGet->selectedId();
 request.CommandType=BG_Type->selectedId();
 request.UseCommandType=(BG_Type->selectedId()!=0);
 request.CommandTime0=timeFrom->dateTime().toTime_t();
 request.UseCommandTime0=timeFromUsed->isChecked();
 request.CommandTime1=timeTo->dateTime().toTime_t();
 request.UseCommandTime1=timeToUsed->isChecked();
 if(!SensorNameMask.isEmpty())
 {
  CopyPtr(&request.SensorID,&request.LSensorID,
          (char*)SensorNameMask.ascii(),SensorNameMask.length()+1); 
  request.UseSensorID=TRUE;
 }
 //--
 IDSet=0;
 if(DBGetCommands(&N, &command, &request,this)==0)
 {
  if(N>0)
  {
 listCommands->setColumnWidthMode (0 , QListView::Manual );
 listCommands->setColumnWidth ( 0, 10 );//enum WidthMode { Manual, Maximum };
// listCommands->setResizeMode();
   //command=new CMessageCommand[N]; AutoFree<CMessageCommand> AF_command(command);
   //DBGetCommands(&N, command, &request,this,&IDSet);
   //for(i=0;i<N;i++)command[i].AllocateStrings();
   //DBGetCommands(&N, command, &request,this,&IDSet);
   //for(i=0;i<N;i++)command[i].AllocateParameters();
   //DBGetCommands(&N, command, &request,this,&IDSet);
//   listCommands->setSortColumn(-1);
   IDFirst=IDLast=0;
  // for(AccSensorID=0,i=0;i<N;i++)AccSensorID=MAX(AccSensorID,command[i].CommandID);
   if(N<100)AccSensorID=3; else AccSensorID=(int)(log10(N)+1);
   for(i=0;i<N;i++)
   {
    QString sn; sn.sprintf("%*.*d",AccSensorID,AccSensorID,(request.TakeFirst1_Last0==0?N-i-1:i));
    QString s0=command[i].SensorID;
    QString s1; s1.sprintf("%d",command[i].CommandID);
    QString s2; s2.sprintf("%d",command[i].CommandType);
    t.setTime_t(command[i].CommandTime);
    QString sp=command[i].AllParameters();

    QString s3=t.toString();//EventTime;
    QListViewItem *item0=new QListViewItem(listCommands,sn,s0,s1,s2,s3,sp);
    listCommands->insertItem(item0);
    if(i==0){IDFirst=IDLast=command[i].CommandID;iFirst=iLast=0;}
    else {IDFirst=MIN(IDFirst,command[i].CommandID); IDLast=MAX(IDLast,command[i].CommandID); iLast=i;}
   }
//   listCommands->setSortColumn(0);
 listCommands->setColumnWidthMode (0 , QListView::Manual );
 listCommands->setColumnWidth ( 0, 30 );//enum WidthMode { Manual, Maximum };
 listCommands->setSorting(0,(request.TakeFirst1_Last0==0?FALSE:TRUE));
   //DBGetCommands(NULL, NULL, NULL,this);//clean internal memory in DB
  }
 }
delete[] command;command=NULL;
return rtn;
}
int CWD_CommandsList::GetNewData()
{//QListView DBGetEvents 
int i,IDSet,rtn=0,N; CMessageCommand *command=NULL; CMessageCommandRequest request; QDateTime t;
 //--
 request.NMax=NMax->text().toInt();//QLineEdit
 request.TakeFirst1_Last0=BG_WhichGet->selectedId();
 request.CommandType=BG_Type->selectedId();
 request.UseCommandType=(BG_Type->selectedId()!=0);
 request.CommandTime0=timeFrom->dateTime().toTime_t();
 request.UseCommandTime0=timeFromUsed->isChecked();
 request.CommandTime1=timeTo->dateTime().toTime_t();
 request.UseCommandTime1=timeToUsed->isChecked();
 //--
  request.CommandID0=IDLast+1;request.UseCommandID0=1;
  request.CommandID1=0       ;request.UseCommandID1=0;
 //--
 if(!SensorNameMask.isEmpty())
 {
  CopyPtr(&request.SensorID,&request.LSensorID,
          (char*)SensorNameMask.ascii(),SensorNameMask.length()+1); 
  request.UseSensorID=TRUE;
 }
 //--
 IDSet=0;
 if(DBGetCommands(&N, &command, &request,this)==0)
 {
  if(N>0)
  {
 listCommands->setColumnWidthMode (0 , QListView::Manual );
 listCommands->setColumnWidth ( 0, 30 );//enum WidthMode { Manual, Maximum };
// listCommands->setResizeMode();
   //command=new CMessageCommand[N]; AutoFree<CMessageCommand> AF_command(command);
   //DBGetCommands(&N, command, &request,this,&IDSet);
   //for(i=0;i<N;i++)command[i].AllocateStrings();
   //DBGetCommands(&N, command, &request,this,&IDSet);
   //for(i=0;i<N;i++)command[i].AllocateParameters();
   //DBGetCommands(&N, command, &request,this,&IDSet);
//   listCommands->setSortColumn(-1);
   for(i=0;i<N;i++)
   {//
    QString sn; sn.sprintf("%*.*d",AccSensorID,AccSensorID,iLast+1+i);
    QString s0=command[i].SensorID;
    QString s1; s1.sprintf("%d",command[i].CommandID);
    QString s2; s2.sprintf("%d",command[i].CommandType);
    QString sp=command[i].AllParameters();
    t.setTime_t(command[i].CommandTime);
    QString s3=t.toString();//EventTime;
    QListViewItem *item0=new QListViewItem(listCommands,sn,s0,s1,s2,s3,sp);
    listCommands->insertItem(item0);
    IDFirst=MIN(IDFirst,command[i].CommandID); IDLast=MAX(IDLast,command[i].CommandID); 
   }
   iLast+=N;
//   listCommands->setSortColumn(0);
 listCommands->setColumnWidthMode (0 , QListView::Manual );
 listCommands->setColumnWidth ( 0, 30 );//enum WidthMode { Manual, Maximum };
 listCommands->setSorting(0,(request.TakeFirst1_Last0==0?FALSE:TRUE));
   //DBGetCommands(NULL, NULL, NULL,this,&IDSet);//clean internal memory in DB
  }
 }
delete[] command;command=NULL;
return rtn;
}

void CWD_CommandsList::onUpdateList()
{
 ResetData();
}

void CWD_CommandsList::noGetNewCommands()
{
 GetNewData();
}

void CWD_CommandsList::onSetTimeFrom(int i)
{
//QString s; s.sprintf("onSetTimeFrom:i=%d",i);
 QDateTime t=QDateTime::currentDateTime();
 if(i==1)t=t.addSecs(-60);//min
 if(i==2)t=t.addSecs(-60*60);//hour
 if(i==3)t=t.addDays(-1);//day
 if(i==4)t=t.addDays(-7);//week
 if(i==5)t=t.addMonths(-1);//month
 if(i==6)t=t.addYears(-1);//year
 timeFrom->setDateTime(t);
 timeFromUsed->setChecked(TRUE);
//qWarning(s.ascii());
}

void CWD_CommandsList::onSetTimeTo(int i)
{
//QString s; s.sprintf("onSetTimeTo:i=%d",i);
 QDateTime t=QDateTime::currentDateTime();
 if(i==1)t=t.addSecs(-60);//min
 if(i==2)t=t.addSecs(-60*60);//hour
 if(i==3)t=t.addDays(-1);//day
 if(i==4)t=t.addDays(-7);//week
 if(i==5)t=t.addMonths(-1);//month
 if(i==6)t=t.addYears(-1);//year
 timeTo->setDateTime(t);
 timeToUsed->setChecked(TRUE);
//qWarning(s.ascii());
}

void CWD_CommandsList::setAutoUpdate(int i)
{
 delete timer; timer=NULL;
 if(i<=0)return;
 timer=new QTimer(this);
 connect( timer, SIGNAL(timeout()), this, SLOT(noGetNewCommands()) );
 timer->start( (i==1?2000:i==2?5000:i==3?1000*60:i==4?1000*60*10:1000), FALSE ); // 2 seconds single-shot timer
 }

void CWD_CommandsList::onRBList(QListViewItem *item,const QPoint &pt,int ip)
{QPoint pt_=pt; pt_=pt_;ip=ip;
itemSelected=item;
 QPopupMenu *Menu0 = new QPopupMenu( this );
   Menu0->insertItem(  "Delete command from DB",  this, SLOT(onDeleteItem()), 0/*CTRL+Key_O*/ );
   Menu0->exec(QCursor::pos());
}

void CWD_CommandsList::onDeleteItem()
{
 if(itemSelected)
 {QString S_ID=itemSelected->text(2); 
  QString str="Delete command with ID="+S_ID+"?";
  if(QMessageBox::question(this,"???",str.ascii(),"Yes","No")==0)
  {
   int id=S_ID.toInt();
   DBDeleteCommand(id);
   delete itemSelected; itemSelected=NULL;
  }
 }
}


void CWD_CommandsList::SetColumnsVisibiliy(int c,int set)//-1=change
{
 ColumnsVisibiliy[c]=Menu1->isItemChecked(Menu1->idAt(c));
 ColumnsVisibiliy[c]=(set==-1?!ColumnsVisibiliy[c]:set);
 Menu1->setItemChecked(Menu1->idAt(c),ColumnsVisibiliy[c]);
  listCommands->setColumnWidthMode(c,ColumnsVisibiliy[0]?QListView::Maximum:QListView::Manual);
  if(!ColumnsVisibiliy[c])
   listCommands->setColumnWidth(c,2);
 ResizeColumns();
}

void CWD_CommandsList::FSetVisibilityC0(){SetColumnsVisibiliy(0,-1);}
void CWD_CommandsList::FSetVisibilityC1(){SetColumnsVisibiliy(1,-1);}
void CWD_CommandsList::FSetVisibilityC2(){SetColumnsVisibiliy(2,-1);}
void CWD_CommandsList::FSetVisibilityC3(){SetColumnsVisibiliy(3,-1);}
void CWD_CommandsList::FSetVisibilityC4(){SetColumnsVisibiliy(4,-1);}
void CWD_CommandsList::FSetVisibilityC5(){SetColumnsVisibiliy(5,-1);}

void CWD_CommandsList::resizeEvent ( QResizeEvent * sz) 
{
QDialog::resizeEvent(sz);
 ResizeColumns();
}

int CWD_CommandsList::ColumnTextWidth(int c)
{int wwMax=0;
 QListViewItem *item=listCommands->firstChild();
 if(item==NULL)return 3;
 wwMax=item->width(listCommands->fontMetrics(),listCommands,c);
 while((item=item->itemBelow())!=NULL)
  wwMax=MAX(wwMax,item->width(listCommands->fontMetrics(),listCommands,c));
return wwMax+3;
}

void CWD_CommandsList::ResizeColumns()
{//return;
 int I,FixedWidth=0,W=listCommands->width(),w1,NFixedFidth=0;
 int w[10],i,NVis,w0,IsFixed[10],wText[10];
 for(NVis=0,i=0;i<NColumns;i++)
 if(ColumnsVisibiliy[i]){NVis++;IsFixed[i]=0;} else {w[i]=2;IsFixed[i]=1;}
 if(NVis>0)
 {
  for(i=0;i<NColumns;i++)wText[i]=ColumnTextWidth(i);
  for(NFixedFidth=0,I=0;I<4;I++)
  {
   if(I==0)w1=(W-(NColumns-NVis)*2)/NVis;
   else    w1=(W-FixedWidth)/(NColumns-NFixedFidth);
   for(NFixedFidth=0,FixedWidth=0,i=0;i<NColumns;i++)
   {
    if(ColumnsVisibiliy[i])
    {
     w[i]=w1;
     w0=wText[i];
     if(w[i]>w0){w[i]=w0;IsFixed[i]=1;}
    }
    if(IsFixed[i]){FixedWidth+=w[i];NFixedFidth++;}
    //listCommands->setColumnWidth(i,w[i]);
   }
   if(NColumns<=NFixedFidth)break;
  }
  //if(NColumns>NFixedFidth)
  {
   w1=(W-FixedWidth)/MAX(1,(NColumns-NFixedFidth));
   for(i=0;i<NColumns;i++)
   {
    if(IsFixed[i])listCommands->setColumnWidth(i,w[i]);
    else listCommands->setColumnWidth(i,(w[i]=w1));
   }
  }
 }
//--
//--
}
void CWD_CommandsList::paintEvent ( QPaintEvent * event)
{
 if(firstPaint){firstPaint=0;ResizeColumns();}
} 

#include "cwd_commandslist.moc"
