/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <qlineedit.h>
#include <qlistview.h>
#include <qdatetime.h>
#include <qdatetimeedit.h>
#include "w.h"
#include "cwd_eventslist.h"

CWD_EventsList::CWD_EventsList(QWidget *parent, const char *name,const char *SensorName)
    :DEventList(parent, name)
{int i;
 NMax->setText("100");
 ResetData();
 listMessages->setColumnWidthMode (0 , QListView::Manual );
 listMessages->setColumnWidth ( 0, 20 );//enum WidthMode { Manual, Maximum };
 IDFirst=0;IDLast=0; iFirst=0;iLast=0;
 //QButtonGroup
 BG_WhichGet->setButton(ELast);
 BG_Type->setButton(EAll);
 AccSensorID=3;
 onSetTimeFrom(2);
 onSetTimeTo(0);
 timeToUsed->setChecked(FALSE);
 timeFromUsed->setChecked(FALSE);
 timer=NULL;
 setCaption(name);
 SensorNameMask=(SensorName?SensorName:"");
 itemSelected=NULL;
update();
 ResetData();
//-----------
 for(i=0;i<10;i++)ColumnsVisibiliy[i]=1;
 NColumns=6;
  Menu1 = new QPopupMenu( this );
         Menu1->setCheckable(TRUE);
         Menu1->insertItem(  "Number",  this, SLOT(FSetVisibilityC0()), 0);
         Menu1->insertItem(  "Sensor",  this, SLOT(FSetVisibilityC1()), 0);
         Menu1->insertItem(  "ID",  this, SLOT(FSetVisibilityC2()), 0);
         Menu1->insertItem(  "Name",  this, SLOT(FSetVisibilityC3()), 0);
         Menu1->insertItem(  "Date",  this, SLOT(FSetVisibilityC4()), 0);
         Menu1->insertItem(  "Params",  this, SLOT(FSetVisibilityC5()), 0);
            Menu1->setItemChecked(Menu1->idAt(0),ColumnsVisibiliy[0]);
            Menu1->setItemChecked(Menu1->idAt(1),ColumnsVisibiliy[1]);
            Menu1->setItemChecked(Menu1->idAt(2),ColumnsVisibiliy[2]);
            Menu1->setItemChecked(Menu1->idAt(3),ColumnsVisibiliy[3]);
            Menu1->setItemChecked(Menu1->idAt(4),ColumnsVisibiliy[4]);
            Menu1->setItemChecked(Menu1->idAt(5),ColumnsVisibiliy[5]);
  //       Menu0->insertSeparator ();
//----------
  QMenuBar *menu = new QMenuBar( this );
  menu->insertItem( "&Columns", Menu1 );
//----------
  itemSelected=NULL;firstPaint=0;
//----------
 ResizeColumns();
//update();
//repaint();
//showFullScreen();
QRect rect=geometry();
//move(rect.left(),rect.top());
setGeometry(rect);
firstPaint=1;
}
void CWD_EventsList::create ( WId window, bool initializeWindow, bool destroyOldWindow)
{
int i=0;
i=0;
QWidget::create ( window, initializeWindow, destroyOldWindow);
}

CWD_EventsList::~CWD_EventsList()
{
 delete timer;timer=NULL;
}

int CWD_EventsList::GetNewData()
{//QListView
int i,IDSet=0,rtn=0,N; CMessageEvent *event=NULL; CMessageEventRequest request; QDateTime t;
 //listMessages->clear();
 //iFirst=iLast=0;
 //--
 request.NMax=NMax->text().toInt();//QLineEdit
 request.TakeFirst1_Last0=BG_WhichGet->selectedId();
 request.MessageType=BG_Type->selectedId();
 request.UseMessageType=(BG_Type->selectedId()!=0);
 request.EventTime0=timeFrom->dateTime().toTime_t();
 request.UseEventTime0=timeFromUsed->isChecked();
 request.EventTime1=timeTo->dateTime().toTime_t();
 request.UseEventTime1=timeToUsed->isChecked();
 //--
  request.MessageID0=IDLast+1;request.UseMessageID0=1;
  request.MessageID1=0       ;request.UseMessageID1=0;
 //--
 if(!SensorNameMask.isEmpty())
 {
  CopyPtr(&request.SensorID,&request.LSensorID,
          (char*)SensorNameMask.ascii(),SensorNameMask.length()+1); 
  request.UseSensorID=TRUE;
 }
 //--
 IDSet=0;
 if(DBGetEvents(&N, &event, &request,this)==0)
 {
  if(N>0)
  {
 listMessages->setColumnWidthMode (0 , QListView::Manual );
 listMessages->setColumnWidth ( 0, 30 );//enum WidthMode { Manual, Maximum };
   //event=new CMessageEvent[N]; AutoFree<CMessageEvent> AF_event(event);
   //DBGetEvents(&N, event, &request,this,&IDSet);
   //for(i=0;i<N;i++)event[i].AllocateStrings();
   //DBGetEvents(&N, event, &request,this,&IDSet);
   //for(i=0;i<N;i++)event[i].AllocateParameters();
   //DBGetEvents(&N, event, &request,this,&IDSet);
   for(i=0;i<N;i++)
   {
    QString sn; sn.sprintf("%*.*d",AccSensorID,AccSensorID,iLast+1+i);
    QString s0=event[i].SensorID;
    QString sID; sID.sprintf("%d",event[i].MessageID);
    QString s1=event[i].EventName;
    t.setTime_t(event[i].EventTime);
    QString sp=event[i].AllParameters();
    QString s2=t.toString();//EventTime;
    QListViewItem *item0=new QListViewItem(listMessages,sn,s0,sID,s1,s2,sp);
    listMessages->insertItem(item0);
    IDFirst=MIN(IDFirst,event[i].MessageID); IDLast=MAX(IDLast,event[i].MessageID); 
   }
   iLast+=N;
//   listMessages->setSortColumn(0);
 listMessages->setColumnWidthMode (0 , QListView::Manual );
 listMessages->setColumnWidth ( 0, 30 );//enum WidthMode { Manual, Maximum };
 listMessages->setSorting(0,(request.TakeFirst1_Last0==0?FALSE:TRUE));
   //DBGetEvents(NULL, NULL, NULL,this,&IDSet);
  }
 }
delete[] event;event=NULL;
return rtn;
}

int CWD_EventsList::ResetData()
{//QListView
int i,IDSet=0,rtn=0,N; CMessageEvent *event=NULL; CMessageEventRequest request; QDateTime t;
 listMessages->clear();
 iFirst=iLast=0;
 //--
 request.NMax=NMax->text().toInt();//QLineEdit
 request.TakeFirst1_Last0=BG_WhichGet->selectedId();
 request.MessageType=BG_Type->selectedId();
 request.UseMessageType=(BG_Type->selectedId()>0);
 request.EventTime0=timeFrom->dateTime().toTime_t();
 request.UseEventTime0=timeFromUsed->isChecked();
 request.EventTime1=timeTo->dateTime().toTime_t();
 request.UseEventTime1=timeToUsed->isChecked();
 //--
 if(!SensorNameMask.isEmpty())
 {
  CopyPtr(&request.SensorID,&request.LSensorID,
          (char*)SensorNameMask.ascii(),SensorNameMask.length()+1); 
  request.UseSensorID=TRUE;
 }
 //--
 IDSet=0;N=0;
 if(DBGetEvents(&N, &event, &request,this)==0)
 {
  if(N<100)AccSensorID=3; else AccSensorID=(int)(log10(N)+1);
  if(N>0)
  {
 listMessages->setColumnWidthMode (0 , QListView::Manual );
 listMessages->setColumnWidth ( 0, 30 );//enum WidthMode { Manual, Maximum };
   //event=new CMessageEvent[N]; AutoFree<CMessageEvent> AF_event(event);
   //DBGetEvents(&N, event, &request,this,&IDSet);
   //for(i=0;i<N;i++)event[i].AllocateStrings();
   //DBGetEvents(&N, event, &request,this,&IDSet);
   //for(i=0;i<N;i++)event[i].AllocateParameters();
   //DBGetEvents(&N, event, &request,this,&IDSet);
   for(i=0;i<N;i++)
   {
    QString sn; sn.sprintf("%*.*d",AccSensorID,AccSensorID,(request.TakeFirst1_Last0==0?N-i-1:i));
    QString s0=event[i].SensorID;
    QString sID; sID.sprintf("%d",event[i].MessageID);
    QString s1=event[i].EventName;
    t.setTime_t(event[i].EventTime);
    QString s2=t.toString();//EventTime;
    QString sp=event[i].AllParameters();
    QListViewItem *item0=new QListViewItem(listMessages,sn,s0,sID,s1,s2,sp);
    listMessages->insertItem(item0);
    if(i==0){IDFirst=IDLast=event[i].MessageID;iFirst=iLast=0;}
    else {IDFirst=MIN(IDFirst,event[i].MessageID); IDLast=MAX(IDLast,event[i].MessageID); iLast=i;}
   }
//   listMessages->setSortColumn(0);
 listMessages->setColumnWidthMode (0 , QListView::Manual );
 listMessages->setColumnWidth ( 0, 30 );//enum WidthMode { Manual, Maximum };
 listMessages->setSorting(0,(request.TakeFirst1_Last0==0?FALSE:TRUE));
   //DBGetEvents(NULL, NULL, NULL,this,&IDSet);
  }
 }
delete[] event;event=NULL;
return rtn;
}

void CWD_EventsList::onUpdateList()
{
 ResetData();
}

void CWD_EventsList::onGetNewEvents()
{
 GetNewData();
}

void CWD_EventsList::onSetTimeFrom(int i)
{
QString s; s.sprintf("CWD_EventsList::onSetTimeFrom:i=%d",i);
qWarning(s.ascii());
 QDateTime t=QDateTime::currentDateTime();//QDateTimeEdit
 if(i==0){}
 else if(i==1) t=t.addSecs(-60);
 else if(i==2) t=t.addSecs(-60*60);
 else if(i==3) t=t.addDays(-1);
 else if(i==4) t=t.addDays(-7);
 else if(i==5) t=t.addMonths(-1);
 else if(i==6) t=t.addYears(-1);
  timeFrom->setDateTime(t); 
 timeFromUsed->setChecked(TRUE);
  
}

void CWD_EventsList::onSetTimeTo(int i)
{
//QString s; s.sprintf("CWD_EventsList::onSetTimeTo:i=%d",i);
 QDateTime t=QDateTime::currentDateTime();
 if(i==1)t=t.addSecs(-60);//min
 if(i==2)t=t.addSecs(-60*60);//hour
 if(i==3)t=t.addDays(-1);//day
 if(i==4)t=t.addDays(-7);//week
 if(i==5)t=t.addMonths(-1);//month
 if(i==6)t=t.addYears(-1);//year
 timeTo->setDateTime(t);
 timeToUsed->setChecked(TRUE);
//qWarning(s.ascii());
}

void CWD_EventsList::setAutoUpdate(int i)
{
 delete timer; timer=NULL;
 if(i<=0)return;
 timer=new QTimer(this);
 connect( timer, SIGNAL(timeout()), this, SLOT(onGetNewEvents()) );
 timer->start( (i==1?2000:i==2?5000:i==3?1000*60:i==4?1000*60*10:1000), FALSE ); // 2 seconds single-shot timer
 }

void CWD_EventsList::onRBList(int i)
{i=i;
}

void CWD_EventsList::onRBList(QListViewItem *item,const QPoint &pt,int ip)
{QPoint pt_=pt;pt_=pt_;ip=ip;
itemSelected=item;
 QPopupMenu *Menu0 = new QPopupMenu( this );
   Menu0->insertItem(  "Delete event from DB",  this, SLOT(onDeleteItem()), 0/*CTRL+Key_O*/ );
   Menu0->exec(QCursor::pos());
}

void CWD_EventsList::onDeleteItem()
{
 if(itemSelected)
 {QString S_ID=itemSelected->text(2); 
  QString str="Delete event with ID="+S_ID+"?";
  if(QMessageBox::question(this,"???",str.ascii(),"Yes","No")==0)
  {
   int id=S_ID.toInt();
   DBDeleteEvent(id);
   delete itemSelected; itemSelected=NULL;
  }
 }
}



void CWD_EventsList::SetColumnsVisibiliy(int c,int set)//-1=change
{
 ColumnsVisibiliy[c]=Menu1->isItemChecked(Menu1->idAt(c));
 ColumnsVisibiliy[c]=(set==-1?!ColumnsVisibiliy[c]:set);
 Menu1->setItemChecked(Menu1->idAt(c),ColumnsVisibiliy[c]);
  listMessages->setColumnWidthMode(c,ColumnsVisibiliy[0]?QListView::Maximum:QListView::Manual);
  if(!ColumnsVisibiliy[c])
   listMessages->setColumnWidth(c,2);
 ResizeColumns();
}

void CWD_EventsList::FSetVisibilityC0(){SetColumnsVisibiliy(0,-1);}
void CWD_EventsList::FSetVisibilityC1(){SetColumnsVisibiliy(1,-1);}
void CWD_EventsList::FSetVisibilityC2(){SetColumnsVisibiliy(2,-1);}
void CWD_EventsList::FSetVisibilityC3(){SetColumnsVisibiliy(3,-1);}
void CWD_EventsList::FSetVisibilityC4(){SetColumnsVisibiliy(4,-1);}
void CWD_EventsList::FSetVisibilityC5(){SetColumnsVisibiliy(5,-1);}

void CWD_EventsList::resizeEvent ( QResizeEvent * sz) 
{
QDialog::resizeEvent(sz);
 ResizeColumns();
}

int CWD_EventsList::ColumnTextWidth(int c)
{int wwMax=0;
 QListViewItem *item=listMessages->firstChild();
 if(item==NULL)return 3;
 wwMax=item->width(listMessages->fontMetrics(),listMessages,c);
 while((item=item->itemBelow())!=NULL)
  wwMax=MAX(wwMax,item->width(listMessages->fontMetrics(),listMessages,c));
return wwMax+3;
}

void CWD_EventsList::ResizeColumns()
{//return;
 int I,FixedWidth=0,W=listMessages->width(),w1,NFixedFidth=0;
 int w[10],i,NVis,w0,IsFixed[10],wText[10];
 for(NVis=0,i=0;i<NColumns;i++)
 if(ColumnsVisibiliy[i]){NVis++;IsFixed[i]=0;} else {w[i]=2;IsFixed[i]=1;}
 if(NVis>0)
 {
  for(i=0;i<NColumns;i++)wText[i]=ColumnTextWidth(i);
  for(NFixedFidth=0,I=0;I<4;I++)
  {
   if(I==0)w1=(W-(NColumns-NVis)*2)/NVis;
   else    w1=(W-FixedWidth)/(NColumns-NFixedFidth);
   for(NFixedFidth=0,FixedWidth=0,i=0;i<NColumns;i++)
   {
    if(ColumnsVisibiliy[i])
    {
     w[i]=w1;
     w0=wText[i];
     if(w[i]>w0){w[i]=w0;IsFixed[i]=1;}
    }
    if(IsFixed[i]){FixedWidth+=w[i];NFixedFidth++;}
    //listMessages->setColumnWidth(i,w[i]);
   }
   if(NColumns<=NFixedFidth)break;
  }
  //if(NColumns>NFixedFidth)
  {
   w1=(W-FixedWidth)/MAX(1,(NColumns-NFixedFidth));
   for(i=0;i<NColumns;i++)
   {
    if(IsFixed[i])listMessages->setColumnWidth(i,w[i]);
    else listMessages->setColumnWidth(i,(w[i]=w1));
   }
  }
 }
//--
update();
repaint();
//--
}

void CWD_EventsList::paintEvent ( QPaintEvent * event)
{
 if(firstPaint){firstPaint=0;ResizeColumns();}
} 


#include "cwd_eventslist.moc"
