/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "w.h"
#include <dlfcn.h>
//==========================================================================
int (*FDBGetSensors)(int *N, CSensor **s)=NULL;
int (*FInitDBSensors)(const char *ConfigWD)=NULL;
int (*FDBGetEvents)(int *N, CMessageEvent **event, CMessageEventRequest *request)=NULL;
int (*FInitDBEvents)(const char *ConfigWD)=NULL;
int (*FDBGetCommands)(int *N, CMessageCommand **event, CMessageCommandRequest *request)=NULL;
int (*FInitDBCommands)(const char *ConfigWD)=NULL;
int DBGetEventsDebug(int *N, CMessageEvent *event, CMessageEventRequest *request);
int (*FDBPutCommand)(CMessageCommand *c)=NULL;
int (*FDBPutEvent)(CMessageEvent *c)=NULL;
int (*FDBDeleteCommand)(int ID)=NULL;
int (*FDBDeleteEvent)(int ID)=NULL;
//==========================================================================
int DBGetSensors(int *N, CSensor **s, QDialog *dlg)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBGetSensors<\n");
#endif
}
 if(FDBGetSensors!=NULL)
 {
  int sizeCSensor=FDBGetSensors(NULL,NULL);
  if(sizeCSensor<=0)
  {QMessageBox::information(dlg,"","DBGetSensors(NULL,NULL) return incorrect value (should return sizeof(CSensor))"); return -1;}
  if(s!=NULL&&sizeCSensor==sizeof(CSensor))
  {
   CSensor *s_=NULL;*N=0;
   rtn=FDBGetSensors(N,&s_);
   if(*N>0&&s_!=NULL)
   {
    delete[] *s; *s=new CSensor[*N];
    int i;
    for(i=0;i<*N;i++)(*s)[i]=(s_)[i];
   }
   FDBGetSensors(NULL,&s_);
  }
   else if(s==NULL)
   {QString s;
    s.sprintf("FDBGetSensors: s==NULL");
    QMessageBox::information(dlg,"",s.ascii()); return -1;
   }
   else
   {QString s;
    s.sprintf
("FDBGetSensors return incorrect struct size:sizeof(CSensor)=%d,return=%d",sizeof(CSensor),sizeCSensor);
    QMessageBox::information(dlg,"",s.ascii()); return -1;
   }
 }
 else
  rtn=DBGetSensorsDebug(N,*s);
{//DeBUG
#ifdef DEBUG_OUT
 printf("DBGetSensors> (rtn=%d; N=%d)\n",rtn,(N?*N:-1));
#endif
}
return rtn;
}
//==========================================================================
int InitDBEvents(QString ConfigWD)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("InitDBEvents<\n");
#endif
}
 if(FInitDBEvents!=NULL)
 {
  rtn=FInitDBEvents(ConfigWD.ascii());
 }
 else
  rtn=InitDBEventsDebug(ConfigWD);
{//DeBUG
#ifdef DEBUG_OUT
 printf("InitDBEventss> \n");
#endif
}
return rtn;
}
//==========================================================================
int InitDBCommands(QString ConfigWD)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("InitDBCommands<\n");
#endif
}
 if(FInitDBCommands!=NULL)
  rtn=FInitDBCommands(ConfigWD.ascii());
 else
  rtn=InitDBCommandsDebug(ConfigWD);
{//DeBUG
#ifdef DEBUG_OUT
 printf("InitDBCommands> \n");
#endif
}
return rtn;
}
//==========================================================================
int InitDBSensors(QString ConfigWD)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("InitDBSensors<\n");
#endif
}
 if(FInitDBSensors!=NULL)
  rtn=FInitDBSensors(ConfigWD.ascii());
 else
  rtn=InitDBSensorsDebug(ConfigWD);
{//DeBUG
#ifdef DEBUG_OUT
 printf("InitDBSensors> \n");
#endif
}
return rtn;
}
//==========================================================================
int InitData()
{int rtn=0;
 if(CurWD.isNull() || CurWD.isEmpty() )
 {
  char *d=get_current_dir_name();//AutoFree<char> AF_d(d);
   CurWD=d;
   {QString s0;
    BaseWD=CurWD+"/..";
    s0.sprintf("%s/../Pics/",CurWD.ascii());
    if(!FileExists(s0+"Red.bmp"))
    {
     BaseWD=CurWD+"/../..";
     s0.sprintf("%s/../../Pics/",CurWD.ascii());
     if(!FileExists(s0+"Red.bmp"))
     {
      BaseWD=CurWD+"/../../..";
      s0.sprintf("%s/../../../Pics/",CurWD.ascii());
      if(!FileExists(s0+"Red.bmp"))
      {
       QMessageBox::information(NULL,"Can't find base dir","Can't find base dir");
       exit(-1);
      }
     }
    }
    if(d)free(d); d=NULL;
   }
 }
 ConfigWD=BaseWD+"/Config";
 DLLWD=BaseWD+"/Libs";
  //     QMessageBox::information(NULL,"Base dir",BaseWD.ascii());
 //-----------------
 LoadDLL(DLLWD);
 InitDBSensors(ConfigWD);
 InitDBEvents(ConfigWD);
 InitDBCommands(ConfigWD);
 //-----------------
return rtn;
}
//==========================================================================
#define DefFun0(ff,sff) sx=GetConfigValue(ss,nss,#ff);ff=(T##ff)dlsym(LibHandle,(sx.isEmpty()?sff:sx)); \
if(ff==NULL){char str[512]; sprintf(str,"Can't load function %s()\n",sff);   printf("%s\n",str); goto lc;}
#define DefFun(ff,sff) sx=GetConfigValue(ss,nss,#ff);ff=(T##ff)dlsym(LibHandle,(sx.isEmpty()?sff:sx)); \
if(ff==NULL){char str[512]; sprintf(str,"Can't load function %s()\n",sff);   printf("%s\n",str); return -1;}
int LoadDLL(QString DLLWD)
{QString sx="",slib=DLLWD+"/DBLib.a";char ss[40][512]; int nss=0;
 if(!FileExists(slib.ascii())){printf("File with library %s not found\n",slib.ascii());return -1;}
 void *LibHandle=dlopen(slib.ascii(), RTLD_LAZY|RTLD_GLOBAL);
// if(!FileExists("../../../Libs/DBLib.a")){printf("File with library %s not found\n","../../../Libs/DBLib.a");}
// void *LibHandle=dlopen("../../../Libs/DBLib.a", RTLD_LAZY|RTLD_GLOBAL);
 //-----------
 FILE *f=fopen(ConfigWD+"/Funs.def","r");
 if(f)
 {
  GetDefs(f, ss,nss);
  fclose(f);
 }
 //-----------GetConfigValue(char (*ss)[512],int &nss,const char *name)
 if(LibHandle==NULL){printf("Can't open library %s\n",slib.ascii());return (0);}
  DefFun0(FDBGetSensors,"_Z13FDBGetSensorsPiPP7CSensor")
  DefFun0(FInitDBSensors,"_Z14FInitDBSensorsPKc")
  DefFun0(FDBGetEvents,"_Z12FDBGetEventsPiPP13CMessageEventP20CMessageEventRequest")
  DefFun0(FInitDBEvents,"_Z13FInitDBEventsPKc")
  DefFun0(FDBGetCommands,"_Z14FDBGetCommandsPiPP15CMessageCommandP22CMessageCommandRequest")
  DefFun0(FInitDBCommands,"_Z15FInitDBCommandsPKc")
  DefFun0(FDBPutCommand,"_Z13FDBPutCommandP15CMessageCommand")
  DefFun0(FDBPutEvent,"_Z11FDBPutEventP13CMessageEvent")
  DefFun0(FDBDeleteCommand,"_Z16FDBDeleteCommandi")
  DefFun0(FDBDeleteEvent,"_Z14FDBDeleteEventi")
  printf("C++ modules are loaded\n");
return 0;
lc:
 printf("Can't load C++ modules. Try to load C modules...\n");
  DefFun(FDBGetSensors,"FDBGetSensors")
  DefFun(FInitDBSensors,"FInitDBSensors")
  DefFun(FDBGetEvents,"FDBGetEvents")
  DefFun(FInitDBEvents,"FInitDBEvents")
  DefFun(FDBGetCommands,"FDBGetCommands")
  DefFun(FInitDBCommands,"FInitDBCommands")
  DefFun(FDBPutCommand,"FDBPutCommand")
  printf("C modules are loaded\n");
return 0;
}
//==========================================================================
int DBPutCommand(CMessageCommand &c)
{
 if(FDBPutCommand==NULL)return -1;
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBPutCommand<\n");
#endif
}
 int rtn=FDBPutCommand(&c);
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBPutCommand<\n");
#endif
}
return rtn;
}
//==========================================================================
int DBPutEvent(CMessageEvent &c)
{
 if(FDBPutEvent==NULL)return -1;
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBPutEvent<\n");
#endif
}
 int rtn=FDBPutEvent(&c);
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBPutEvent<\n");
#endif
}
return rtn;
}
//==========================================================================
int DBGetEvents(int *N, CMessageEvent **event, CMessageEventRequest *request, QDialog *dlg)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBGetEvents<\n");
#endif
}
 if(FDBGetEvents!=NULL)
 {
  int rtnSize=FDBGetEvents(NULL, NULL, NULL);
  int sizeCMessageEvent=rtnSize&(255|(255<<8));
  int sizeCMessageEventRequest=(rtnSize>>16)&(255|(255<<8));
  if(rtnSize<=0 || sizeCMessageEvent<=0||sizeCMessageEventRequest<=0)
  {QMessageBox::information(dlg,"","FDBGetEvents(NULL,NULL,NULL) return incorrect value (should return sizeof(CMessageEvent)|(sizeof(CMessageEventRequest)<<16))"); return -1;}
  if(
      event!=NULL&&
      sizeCMessageEvent==sizeof(CMessageEvent) &&
      sizeCMessageEventRequest==sizeof(CMessageEventRequest)
    )
  {CMessageEvent *event_=NULL; *N=0;
   rtn=FDBGetEvents(N, &event_, request);
   if(*N>0&&event_!=NULL)
   {
    delete[] *event; *event=new CMessageEvent[*N];
    int i;
    for(i=0;i<*N;i++)(*event)[i]=(event_)[i];
   }
   FDBGetEvents(NULL, &event_, request);
  }
   else if(event==NULL)
   {QString s;
    s.sprintf("FDBGetEvents:event==NULL");
    QMessageBox::information(dlg,"",s.ascii()); return -1;
   }
   else
   {QString s;
    s.sprintf("FDBGetEvents return incorrect struct size:sizeof(CMessageEvent)=%d,return=%d; size(CCMessageEventRequest)=%d,return=%d",sizeof(CMessageEvent),sizeCMessageEvent,sizeof(CMessageEventRequest),sizeCMessageEventRequest);
    QMessageBox::information(dlg,"",s.ascii()); return -1;
   }
 }
 else
  rtn=DBGetEventsDebug(N, *event, request);
{//DeBUG
#ifdef DEBUG_OUT
 printf("DBGetEvents> \n");
#endif
}
return rtn;
}
//==========================================================================
int DBGetCommands(int *N, CMessageCommand **command, CMessageCommandRequest *request, QDialog *dlg)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBGetCommands<\n");
#endif
}
 if(FDBGetCommands!=NULL)
 {
  int rtnSize=FDBGetCommands(NULL, NULL, NULL);
  int sizeCMessageCommand=rtnSize&(255|(255<<8));
  int sizeCMessageCommandRequest=(rtnSize>>16)&(255|(255<<8));
  if(rtnSize<=0 || sizeCMessageCommand<=0||sizeCMessageCommandRequest<=0)
  {QMessageBox::information(dlg,"","FDBGetCommands(NULL,NULL,NULL) return incorrect value (should return sizeof(CMessageCommand)|(sizeof(CMessageCommandRequest)<<16))"); return -1;}
  if(
      command!=NULL&&
      sizeCMessageCommand==sizeof(CMessageCommand) &&
      sizeCMessageCommandRequest==sizeof(CMessageCommandRequest)
    )
   {CMessageCommand *command_=NULL; *N=0;
    rtn=FDBGetCommands(N, &command_, request);
    if(*N>0&&command_!=NULL)
    {
     delete[] *command; *command=new CMessageCommand[*N];
     int i;
     for(i=0;i<*N;i++)(*command)[i]=(command_)[i];
    }
    FDBGetCommands(NULL, &command_, request);
   }
   else if(command==NULL)
   {QString s;
    s.sprintf("FDBGetCommands:command==NULL");
    QMessageBox::information(dlg,"",s.ascii()); return -1;
   }
   else
   {QString s;
    s.sprintf("FDBGetCommands return incorrect struct size:sizeof(CMessageCommand)=%d,return=%d; size(CMessageCommandRequest)=%d,return=%d",sizeof(CMessageCommand),sizeCMessageCommand,sizeof(CMessageCommandRequest),sizeCMessageCommandRequest);
    QMessageBox::information(dlg,"",s.ascii()); return -1;
   }
 }
 else
  rtn=DBGetCommandsDebug(N, *command, request);
{//DeBUG
#ifdef DEBUG_OUT
 printf("DBGetCommands> \n");
#endif
}
return rtn;
}
//==========================================================================
int DBDeleteCommand(int ID)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBDeleteCommand<\n");
#endif
}
 if(FDBDeleteCommand!=NULL)
 {
  FDBDeleteCommand(ID);
 }
{//DeBUG
#ifdef DEBUG_OUT
 printf("DBDeleteCommand> \n");
#endif
}
return rtn;
}
//==========================================================================
int DBDeleteEvent(int ID)
{int rtn=0;
{//DEBUG
#ifdef DEBUG_OUT
 printf("DBDeleteEvent<\n");
#endif
}
 if(FDBDeleteEvent!=NULL)
 {
  FDBDeleteEvent(ID);
 }
{//DeBUG
#ifdef DEBUG_OUT
 printf("DBDeleteEvent> \n");
#endif
}
return rtn;
}
//==========================================================================
