/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "w.h"
//==========================================================================
void CMessageCommand::clean()
{
 MessageType=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0;
 CommandID=0;
 CommandType=0;
 CommandTime=0;
 delete[] par;
 par=NULL;
 ParNum=0;
 delete[] CommandName; CommandName=NULL;LCommandName=0;
 delete[] ResultInfo; ResultInfo=NULL;LResultInfo=0;
 Result=0;

}
//==========================================================================
void CMessageCommand::Set(int MessageType,char *SensorID,int CommandType)
{ QDateTime t=QDateTime::currentDateTime();
 this->MessageType=MessageType;
 CopyPtr(&this->SensorID,&this->LSensorID,SensorID,strlen(SensorID)+1);
 this->CommandType=CommandType;
 CommandTime=t.toTime_t();
}
//==========================================================================
/* int MessageType;
 char *SensorID; int LSensorID;
 int CommandID;
 int CommandType;
 time_t EventTime;
 int ParNum;
 CMessageEventParam *par;
*/
CMessageCommand &CMessageCommand::operator=(const CMessageCommand &b)
{int i;
if(this==&b)return *this;
 MessageType=b.MessageType;
 CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
 CopyPtr(&CommandName,&LCommandName,b.CommandName,b.LCommandName);
 CopyPtr(&ResultInfo,&LResultInfo,b.ResultInfo,b.LResultInfo);
 Result=b.Result;
 CommandType=b.CommandType;
 CommandTime=b.CommandTime;
 CommandID=b.CommandID;
 if(ParNum!=b.ParNum)
 {
  delete[] par; par=NULL;
  ParNum=b.ParNum;
  if(ParNum>0)
  {
   par=new CMessageEventParam[ParNum];
  }
 }
 for(i=0;i<ParNum;i++)
  par[i]=b.par[i];
return *this;
}
/*
 int MessageType;
 char *SensorID;
 int SensorType;
 char *EventName;
 time_t EventTime;
 int MessageID;//random number (?)
 int ParNum;
 CMessageParam *par;
*/
//==========================================================================
inline void CopyPtr(char **to, int *lto, char *from,int lfrom)
{
 delete[] *to; *to=NULL;*lto=0; 
 if(lfrom>0)
 {
  *lto=lfrom; *to=new char[lfrom]; memcpy(*to,from,lfrom);
 }
}
//==========================================================================
void CMessageCommandRequest::clean()
{
 NMax=100; TakeFirst1_Last0=0;
 MessageType=0; UseMessageType=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0; UseSensorID=0;
 CommandType=0; UseCommandType=0; 
 CommandID0=0; UseCommandID0=0; 
 CommandID1=0; UseCommandID1=0; 
 CommandTime0=0; UseCommandTime0=0;
 CommandTime1=0; UseCommandTime1=0;

}
//==========================================================================
int CMessageCommandRequest::operator&(CMessageCommand &ev)
{int rtn=1;
 if(UseMessageType && MessageType!=ev.MessageType)return 0;
 if(UseSensorID && WCompareNoCase(SensorID,ev.SensorID)!=0)return 0;
 if(UseCommandID0 && CommandID0>ev.CommandID)return 0;
 if(UseCommandID1 && CommandID1<ev.CommandID)return 0;
 if(UseCommandType && CommandType!=ev.CommandType)return 0;
 if(UseCommandTime0 && ev.CommandTime<CommandTime0)return 0;
 if(UseCommandTime1 && ev.CommandTime>CommandTime1)return 0;
return rtn;
}
//==========================================================================
/* int NMax;int TakeFirst1_Last0;
 int MessageType; int UseMessageType;
 char *SensorID; int LSensorID; int UseSensorID;
 int CommandID; int UseCommandID; 
 int CommandType; int UseCommandType; 
 time_t EventTime0; int UseEventTime0;
 time_t EventTime1; int UseEventTime1;
*/
CMessageCommandRequest &CMessageCommandRequest::operator=(const CMessageCommandRequest &b)
{
if(this==&b)return *this;
 NMax=b.NMax; TakeFirst1_Last0=b.TakeFirst1_Last0;
 MessageType=b.MessageType; UseMessageType=b.UseMessageType;
 CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID); UseSensorID=b.UseSensorID;
 CommandID0=b.CommandID0; UseCommandID0=b.UseCommandID0; 
 CommandID1=b.CommandID1; UseCommandID1=b.UseCommandID1; 
 CommandType=b.CommandType; UseCommandType=b.UseCommandType; 
 CommandTime0=b.CommandTime0; UseCommandTime0=b.UseCommandTime0;
 CommandTime1=b.CommandTime1; UseCommandTime1=b.UseCommandTime1;
return *this;
}
//==========================================================================
void CMessageCommand::AllocateStrings()
{
 delete SensorID;SensorID=NULL; if(LSensorID>0)SensorID=new char[LSensorID+1];
 delete[] par;par=NULL;if(ParNum>0)par=new CMessageEventParam[ParNum];
 delete[] CommandName; CommandName=new char[LCommandName+1];
 delete[] ResultInfo; ResultInfo=new char[LResultInfo+1];
}
//==========================================================================
void CMessageCommand::AllocateParameters()
{int i; 
 if(par)for(i=0;i<ParNum;i++)par[i].AllocateStrings();
}
//==========================================================================
QString CMessageCommand::AllParameters()
{QString s=""; int i;
 if(par!=NULL && ParNum>0)
 {
 //int Type;//text: 1)int; 2)double; 3)text
 //char *Name;int LName;//0-terminated
 //char *Val; int LVal;
  for(i=0;i<ParNum;i++)
  {
   s+=(par[i].Name?par[i].Name:"(NULL)");
   s+="=";
   s+=par[i].toString();
   if(i<ParNum-1)s+=";";
  }
 }
return s;
}
//==========================================================================
