/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "w.h"
//==========================================================================
void CMessageEvent::clean()
{
 MessageType=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0;
 SensorType=0;MessageID=0;
 delete[] EventName; EventName=NULL; LEventName=0;
 EventTime=0;
 MessageID=0;
 delete[] par;
 par=NULL;
 ParNum=0;
}
//=12=========================================================================
CMessageEvent &CMessageEvent::operator=(const CMessageEvent &b)
{int i;
if(this==&b)return *this;
 MessageID=b.MessageID;
 MessageType=b.MessageType;
 CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID);
 SensorType=b.SensorType;
 CopyPtr(&EventName,&LEventName,b.EventName,b.LEventName);
 EventTime=b.EventTime;
 MessageID=b.MessageID;
 if(ParNum!=b.ParNum)
 {
  delete[] par; par=NULL;
  ParNum=b.ParNum;
  if(ParNum>0)
  {
   par=new CMessageEventParam[ParNum];
  }
 }
 for(i=0;i<ParNum;i++)
  par[i]=b.par[i];
return *this;
}
/*
 int MessageType;
 char *SensorID;
 int SensorType;
 char *EventName;
 time_t EventTime;
 int MessageID;//random number (?)
 int ParNum;
 CMessageParam *par;
*/
//==========================================================================
inline void CopyPtr(char **to, int *lto, char *from,int lfrom)
{
 delete[] *to; *to=NULL;*lto=0; 
 if(lfrom>0)
 {
  *lto=lfrom; *to=new char[lfrom]; memcpy(*to,from,lfrom);
 }
}
//==========================================================================
void CMessageEventRequest::clean()
{
 NMax=100; TakeFirst1_Last0=0;
 MessageType=0; UseMessageType=0;
 MessageID0=0; UseMessageID0=0;
 MessageID1=0; UseMessageID1=0;
 delete[] SensorID; SensorID=NULL; LSensorID=0; UseSensorID=0;
 SensorType=0; UseSensorType=0; 
 delete[] EventName; EventName=NULL; LEventName=0; UseEventName=0;
 EventTime0=0; UseEventTime0=0;
 EventTime1=0; UseEventTime1=0;
}
//==========================================================================
int CMessageEventRequest::operator&(CMessageEvent &ev)
{int rtn=1;
 if(UseMessageID0 && ev.MessageID<MessageID0)return 0;
 if(UseMessageID1 && ev.MessageID>MessageID1)return 0;
 if(UseMessageType && MessageType!=ev.MessageType)return 0;
 if(UseSensorID && WCompareNoCase(SensorID,ev.SensorID)!=0)return 0;
 if(UseSensorType && SensorType!=ev.SensorType)return 0;
 if(UseEventName && WCompareNoCase(EventName,ev.EventName)!=0)return 0;
 if(UseEventTime0 && ev.EventTime<EventTime0)return 0;
 if(UseEventTime1 && ev.EventTime>EventTime1)return 0;
return rtn;
}
//==========================================================================
CMessageEventRequest &CMessageEventRequest::operator=(const CMessageEventRequest &b)
{
if(this==&b)return *this;
 NMax=b.NMax; TakeFirst1_Last0=b.TakeFirst1_Last0;
 MessageID0=b.MessageID0; UseMessageID0=b.UseMessageID0;
 MessageID1=b.MessageID1; UseMessageID1=b.UseMessageID1;
 MessageType=b.MessageType; UseMessageType=b.UseMessageType;
 CopyPtr(&SensorID,&LSensorID,b.SensorID,b.LSensorID); UseSensorID=b.UseSensorID;
 SensorType=b.SensorType; UseSensorType=b.UseSensorType; 
 CopyPtr(&EventName,&LEventName,b.EventName,b.LEventName); UseEventName=b.UseEventName;
 EventTime0=b.EventTime0; UseEventTime0=b.UseEventTime0;
 EventTime1=b.EventTime1; UseEventTime1=b.UseEventTime1;
return *this;
}
//==========================================================================
 void CMessageEvent::AllocateStrings()
{
 delete SensorID;SensorID=NULL; if(LSensorID>0)SensorID=new char[LSensorID+1];
 delete EventName;EventName=NULL; if(LEventName>0)EventName=new char[LEventName+1]; 
 delete[] par;par=NULL; if(ParNum>0)par=new CMessageEventParam[ParNum];
}
//==========================================================================
QString CMessageEvent::AllParameters()
{QString s=""; int i;
 if(par!=NULL && ParNum>0)
 {
 //int Type;//text: 1)int; 2)double; 3)text
 //char *Name;int LName;//0-terminated
 //char *Val; int LVal;
  for(i=0;i<ParNum;i++)
  {
   s+=(par[i].Name?par[i].Name:"(NULL)");
   s+="=";
   s+=par[i].toString();
   if(i<ParNum-1)s+=";";
  }
 }
return s;
}
//==========================================================================
QString CMessageEventParam::toString()
{QString s="";
 if(this==NULL){s="(null)";return s;}
 if(Val)
 {
  if(Type==1)s.sprintf("%d",*(int*)Val);
  else if(Type==2)s.sprintf("%lg",*(double*)Val);
  else if(Type==3)s=Val;
 }
return s;
}


