/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CWD_COMMANDSLIST_H
#define CWD_COMMANDSLIST_H

#include "CommandsList.h"
#include <qtimer.h>

class CWD_CommandsList: public DCommandsList {
Q_OBJECT
public:
    CWD_CommandsList(QWidget *parent = 0, const char *name = 0,const char *SensorName=NULL);
    ~CWD_CommandsList();
    int ResetData();
    int GetNewData();
    //--
    int IDFirst,IDLast;enum {EFirst=1,ELast=0}; enum{EAll=0,EAnalysers=1,EConverters=2,EReceivers=3};
    int iFirst,iLast;
    int AccSensorID;
    QTimer *timer;
    QListViewItem *itemSelected;
    int firstPaint;
    //--
    QString SensorNameMask;
    //--
    QPopupMenu *Menu1;
    int ColumnsVisibiliy[10];int NColumns;
    void SetColumnsVisibiliy(int c,int set);//-1=change
    void ResizeColumns();
    int ColumnTextWidth(int c);
    //---
    void resizeEvent ( QResizeEvent * sz); 
    void paintEvent ( QPaintEvent * event);
    //---
public slots:
    virtual void onUpdateList();
    virtual void noGetNewCommands();
    virtual void onSetTimeFrom(int i);
    virtual void onSetTimeTo(int i);
    virtual void setAutoUpdate(int i);
    virtual void onRBList(QListViewItem *,const QPoint &pt,int );
    virtual void onDeleteItem();
protected slots:
    void FSetVisibilityC0();
    void FSetVisibilityC1();
    void FSetVisibilityC2();
    void FSetVisibilityC3();
    void FSetVisibilityC4();
    void FSetVisibilityC5();
};

#endif
