/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "w.h"
#include "cwd_eventslist.h"
#include "cwd_sensorslist.h"
#include "cwd_commandslist.h"


CWD_SensorsList::CWD_SensorsList(QWidget *parent, const char *name)
    :Form1(parent, name)
{int i;
//QListView
 //SensorsList->clear();
 //SensorsList->addColumn("ID");
 //SensorsList->addColumn("Description");
 NSensors=0; Sensor=NULL;
 for(i=0;i<10;i++)ColumnsVisibiliy[i]=1;
 NColumns=3;
update();
 ResetData(); 
//----------
  Menu0 = new QPopupMenu( this );
         Menu0->insertItem(  "Update data",  this, SLOT(FUpdateData()), 0);
  //       Menu0->insertSeparator ();
//----------
  Menu1 = new QPopupMenu( this );
         Menu1->setCheckable(TRUE);
         Menu1->insertItem(  "Number",  this, SLOT(FSetVisibilityC0()), 0);
         Menu1->insertItem(  "Description",  this, SLOT(FSetVisibilityC1()), 0);
         Menu1->insertItem(  "Is alive",  this, SLOT(FSetVisibilityC2()), 0);
            Menu1->setItemChecked(Menu1->idAt(0),ColumnsVisibiliy[0]);
            Menu1->setItemChecked(Menu1->idAt(1),ColumnsVisibiliy[1]);
            Menu1->setItemChecked(Menu1->idAt(2),ColumnsVisibiliy[2]);
  //       Menu0->insertSeparator ();
//----------
  QMenuBar *menu = new QMenuBar( this );
  menu->insertItem( "&Menu", Menu0 );
  menu->insertItem( "&Columns", Menu1 );
//----------
  itemSelected=NULL;
//----------
 ResizeColumns();
}

CWD_SensorsList::~CWD_SensorsList()
{//int i;
 delete[] Sensor; Sensor=NULL; NSensors=0;
}


void CWD_SensorsList::ResetData()
{//int IDSet=0;
 SensorsList->clear();
 NSensors=0; delete[] Sensor; Sensor=NULL;
 int rtn=DBGetSensors(&NSensors, &Sensor,this); rtn=rtn;
 if(NSensors>0)
 {int i;
  //Sensor=new CSensor[NSensors]; //AutoFree<CSensor> AF_SensorSensor(Sensor);
  //rtn=DBGetSensors(&NSensors, Sensor,this,&IDSet);
  //    for(i=0;i<NSensors;i++)Sensor[i].AllocateStrings();
  //    DBGetSensors(&NSensors, Sensor,this,&IDSet);
  for(i=0;i<NSensors;i++)
  {
   QString s0=Sensor[i].SensorID;
   QString s1=Sensor[i].Description;
   QString s2=(Sensor[i].MessageType==1?"Is Alive":Sensor[i].MessageType==2?"IsDead":"");
   QListViewItem *item0=new QListViewItem(SensorsList,s0,s1,s2);
   SensorsList->insertItem(item0);
   //QListViewItem *item1=new QListViewItem(SensorsList,item0,s);
   //item0->insertItem(item1);
  }
  //DBGetSensors(NULL, NULL,this);;
 }
}

void CWD_SensorsList::FUpdateData()
{
//#ifdef DEBUG_DB
 InitDBSensors(ConfigWD);
//#endif
 ResetData();
}

void CWD_SensorsList::Form1_destroyed(QObject*)
{int i=0;
i=1;
}

void CWD_SensorsList::onClose()
{
}
void CWD_SensorsList::reject()
{int i=0;
i=1;
delete this;
}

void CWD_SensorsList::onRBList(QListViewItem *item,const QPoint &pt,int ip)
{QPoint pt_=pt;pt_=pt_; ip=ip;
itemSelected=item;
 QPopupMenu *Menu0 = new QPopupMenu( this );
   Menu0->insertItem(  "Events List Dialog",  this, SLOT(CallEventsDialog()), 0/*CTRL+Key_O*/ );
   Menu0->insertItem(  "Commands List Dialog", this, SLOT(CallCommandsDialog()), 0/*CTRL+Key_N*/ );
   Menu0->insertSeparator ();
   Menu0->insertItem(  "Start",  this, SLOT(FStart()), 0/*CTRL+Key_O*/ );
   Menu0->insertItem(  "Stop", this, SLOT(FStop()), 0/*CTRL+Key_N*/ );
   Menu0->insertItem(  "Restart", this, SLOT(FRestart()), 0/*CTRL+Key_N*/ );
   Menu0->insertItem(  "Kill", this, SLOT(FKill()), 0/*CTRL+Key_N*/ );
   Menu0->exec(QCursor::pos());
}

void CWD_SensorsList::CallEventsDialog()
{
 if(itemSelected)
 {QString SensorName=itemSelected->text(0),title="Events list for ";
  title+=SensorName;
  CWD_EventsList *events_list=new CWD_EventsList(this, title.ascii(),SensorName.ascii());
   events_list->show();
 }
}

void CWD_SensorsList::CallCommandsDialog()
{//Form1
 if(itemSelected)
 {QString SensorName=itemSelected->text(0),title="Commands list for ";
  title+=SensorName;
  CWD_CommandsList *commands_list=new CWD_CommandsList(this, title.ascii(),SensorName.ascii());
   commands_list->show();
 }
}

void CWD_SensorsList::FStart()
{
 if(itemSelected)
 {
  CMessageCommand c; QString SensorName=itemSelected->text(0);
// int MessageType;//1=std
// char *SensorID; int LSensorID;
// int CommandID;//internal value for DB; is defined when record is created
// int CommandType;//1)start; 2)stop; 3)restart; 4)kill
  c.Set(1,(char*)SensorName.ascii(),1);
  DBPutCommand(c);
 }
}

void CWD_SensorsList::FStop()
{
 if(itemSelected)
 {
  CMessageCommand c; QString SensorName=itemSelected->text(0);
  c.Set(1,(char*)SensorName.ascii(),2);
  DBPutCommand(c);
 }
}

void CWD_SensorsList::FKill()
{
 if(itemSelected)
 {
  CMessageCommand c; QString SensorName=itemSelected->text(0);
  c.Set(1,(char*)SensorName.ascii(),4);
  DBPutCommand(c);
 }
}

void CWD_SensorsList::FRestart()
{
 if(itemSelected)
 {
  CMessageCommand c; QString SensorName=itemSelected->text(0);
  c.Set(1,(char*)SensorName.ascii(),3);
  DBPutCommand(c);
 }
}

void CWD_SensorsList::SetColumnsVisibiliy(int c,int set)//-1=change
{
 ColumnsVisibiliy[c]=Menu1->isItemChecked(Menu1->idAt(c));
 ColumnsVisibiliy[c]=(set==-1?!ColumnsVisibiliy[c]:set);
 Menu1->setItemChecked(Menu1->idAt(c),ColumnsVisibiliy[c]);
  SensorsList->setColumnWidthMode(c,ColumnsVisibiliy[0]?QListView::Maximum:QListView::Manual);
  if(!ColumnsVisibiliy[c])
   SensorsList->setColumnWidth(c,2);
 ResizeColumns();
}

void CWD_SensorsList::FSetVisibilityC0()
{
SetColumnsVisibiliy(0,-1);
}

void CWD_SensorsList::FSetVisibilityC1()
{
SetColumnsVisibiliy(1,-1);
}

void CWD_SensorsList::FSetVisibilityC2()
{
SetColumnsVisibiliy(2,-1);
}

void CWD_SensorsList::resize ( int w, int h )
{
w=w;h=h;
}

void CWD_SensorsList::resizeEvent ( QResizeEvent * sz) 
{
QDialog::resizeEvent(sz);
 ResizeColumns();
}

int CWD_SensorsList::ColumnTextWidth(int c)
{int wwMax=0;
 QListViewItem *item=SensorsList->firstChild();
 if(item==NULL)return 3;
 wwMax=item->width(SensorsList->fontMetrics(),SensorsList,c);
 while((item=item->itemBelow())!=NULL)
  wwMax=MAX(wwMax,item->width(SensorsList->fontMetrics(),SensorsList,c));
return wwMax+3;
}

void CWD_SensorsList::ResizeColumns()
{
 int I,FixedWidth=0,W=SensorsList->width(),w1,NFixedFidth=0;
 int w[10],i,NVis,w0,IsFixed[10],wText[10];
 for(NVis=0,i=0;i<NColumns;i++)
 if(ColumnsVisibiliy[i]){NVis++;IsFixed[i]=0;} else {w[i]=2;IsFixed[i]=1;}
 if(NVis>0)
 {
  for(i=0;i<NColumns;i++)wText[i]=ColumnTextWidth(i);
  for(NFixedFidth=0,I=0;I<4;I++)
  {
   if(I==0)w1=(W-(NColumns-NVis)*2)/NVis;
   else    w1=(W-FixedWidth)/(NColumns-NFixedFidth);
   for(NFixedFidth=0,FixedWidth=0,i=0;i<NColumns;i++)
   {
    if(ColumnsVisibiliy[i])
    {
     w[i]=w1;
     w0=wText[i];
     if(w[i]>w0){w[i]=w0;IsFixed[i]=1;}
    }
    if(IsFixed[i]){FixedWidth+=w[i];NFixedFidth++;}
    //SensorsList->setColumnWidth(i,w[i]);
   }
   if(NColumns<=NFixedFidth)break;
  }
  //if(NColumns>NFixedFidth)
  {
   w1=(W-FixedWidth)/MAX(1,(NColumns-NFixedFidth));
   for(i=0;i<NColumns;i++)
   {
    if(IsFixed[i])SensorsList->setColumnWidth(i,w[i]);
    else SensorsList->setColumnWidth(i,(w[i]=w1));
   }
  }
 }
//--
//--
}


#include "cwd_sensorslist.moc"
