/***************************************************************************
 *   Copyright (C) 2007 by valter   *
 *   staroverovv@yandx.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __STR_H__
#define __STR_H__
//==========================================================================
#include <time.h>
#include <string.h>
#include <stdlib.h>
//==========================================================================
class CMessageEventParam
{public:
 //--
 CMessageEventParam(){memset(this,0,sizeof(*this));}
 ~CMessageEventParam(){clean();}
 //--
 void clean();
 CMessageEventParam &operator=(const CMessageEventParam &b);
 void AllocateStrings(){delete Name;Name=NULL; if(LName>0)Name=new char[LName+1]; delete Val;Val=NULL; if(LVal>0)Val=new char[LVal+1];}
 QString toString();//{QString s="";if(Val){if(Type==1)s.sprintf("%d",*(int*)Val);}return s;}
 //--
 int Type;//text: 1)int; 2)double; 3)text
 char *Name;int LName;//0-terminated
 char *Val; int LVal;
 //--
};
//==========================================================================
class CMessageEvent
{public:
 //---
 CMessageEvent(){memset(this,0,sizeof(*this));}
 ~CMessageEvent(){clean();}
//---
 void clean();
 CMessageEvent &operator=(const CMessageEvent &b);
 void AllocateStrings();
 void AllocateParameters(){int i; if(par)for(i=0;i<ParNum;i++)par[i].AllocateStrings();}
 QString AllParameters();
//---
 int MessageType;
 char *SensorID; int LSensorID;
 int MessageID;//internal value for DB; is defined when record is created
 int SensorType;
 char *EventName; int LEventName;
 time_t EventTime;
 int ParNum;
 CMessageEventParam *par;
//---
};
//==========================================================================
class CMessageEventRequest
{public:
//--
 CMessageEventRequest(){memset(this,0,sizeof(*this));}
 ~CMessageEventRequest(){clean();}
//--
 void clean();
 CMessageEventRequest &operator=(const CMessageEventRequest &b);
 int operator&(CMessageEvent &ev);
//--
 int NMax;int TakeFirst1_Last0;
 int MessageID0,MessageID1; int UseMessageID0,UseMessageID1;
 int MessageType; int UseMessageType;
 char *SensorID; int LSensorID; int UseSensorID;
 int SensorType; int UseSensorType; 
 char *EventName; int LEventName; int UseEventName;
 time_t EventTime0; int UseEventTime0;
 time_t EventTime1; int UseEventTime1;
//--
};
//==========================================================================
class CMessageKeepAlive
{public:
//--
 CMessageKeepAlive(){memset(this,0,sizeof(*this));}
 CMessageKeepAlive &operator=(const CMessageKeepAlive &b);
~CMessageKeepAlive(){clean();}
//--
 void clean();
//--
 int MessageType;
 char *SensorID; int LSensorID;
 int SensorType; 
 time_t EventTime;
//-
};
//==========================================================================
class CMessageCommand
{public:
//---
 CMessageCommand(){memset(this,0,sizeof(*this));}
 ~CMessageCommand(){clean();}
//---
 void clean();
 CMessageCommand &operator=(const CMessageCommand &b);
 void AllocateStrings();
 void AllocateParameters();
 QString AllParameters();
 void Set(int MessageType,char *SensorID,int CommandType);
//---
 int MessageType;//1=std
 char *SensorID; int LSensorID;
 int CommandID;//internal value for DB; is defined when record is created
 int CommandType;//1)start; 2)stop; 3)restart; 4)kill
 time_t CommandTime;
 int ParNum;
 CMessageEventParam *par;
//-- ADD1(24.11.07)
 char *CommandName; int LCommandName;
//--- result of command execution:
 int Result;
 char *ResultInfo; int LResultInfo;
};
//==========================================================================
class CMessageCommandRequest
{public:
//--
 CMessageCommandRequest(){memset(this,0,sizeof(*this));}
 ~CMessageCommandRequest(){clean();}
//--
 void clean();
 CMessageCommandRequest &operator=(const CMessageCommandRequest &b);
 int operator&(CMessageCommand &ev);
//--
 int NMax;int TakeFirst1_Last0;
 int MessageType; int UseMessageType;
 char *SensorID; int LSensorID; int UseSensorID;
 int CommandID0,CommandID1; int UseCommandID0,UseCommandID1; 
 int CommandType; int UseCommandType; 
 time_t CommandTime0; int UseCommandTime0;
 time_t CommandTime1; int UseCommandTime1;
//--
};
//==========================================================================
class CSensor
{public:
//--
 CSensor(){memset(this,0,sizeof(*this));}
 ~CSensor(){clean();}
//---
 void clean();
 CSensor &operator=(const CSensor &b);
 void AllocateStrings();
//--
 int SensorType;
 char *SensorID; int LSensorID;
 char *Description; int LDescription;
//-- for KEEPALIVE:
 int MessageType;//1)IsAlive; 2)IsDead
 time_t EventTime;
 int Status;//bits: 1=Alive/Not alive
//-- ADD1(24.11.07)
 char *SocketNameForCommands; int LSocketNameForCommands;
//--
};
//==========================================================================
int InitData();
void CopyPtr(char **to, int *lto, char *from,int lfrom);
int LoadDLL(QString DLLWD);
//{to=NULL;*lto=0; if(lfrom>0){*lto=lfrom; to=new char[lfrom]; mecmpy(to,from,lfrom);}}
//inline int FileExists(const char*sf){FILE *f=fopen(sf,"r"); if(f){fclose(f);return 1;} return 0;}
//==========================================================================
#endif
